Digi RealPort for Windows Help

Welcome to Digi RealPort for Windows Help!

Introduction

This document contains general information about operating Digi RealPort devices from Windows. It also includes information about the Digi RealPort Device Driver and Setup Wizard for Windows.

It is assumed the reader has general knowledge of the Windows Operating System and TCP/IP communications.

Please note when installing, configuring and removing the Realport driver, you must be logged in as Administrator or as a member of the Administrator group. Furthermore, if you are installing across a Remote Desktop Connection, you must start Remote Desktop with the "/console" switch, i.e., "%SystemRoot%\System32\mstsc.exe /console".

Supported Products

Digi Connect Family
Digi ConnectPort Family
Digi EtherLite Family
Digi One Family
Digi PortServer Family
Digi PortServer TS Family

Software Updates

Please visit the Digi Web site for product and software support, as well as downloads of the latest Windows drivers and device firmwares.


Installing Digi RealPort for Windows

Only a user with Administrative privileges may install device drivers in Windows.

Please log on as Administrator or as a user that is a member of the Administrators group.

Remote Desktop users: If installing across a Remote Desktop Connection, you must start Remote Desktop with the "console" switch, i.e., "%SystemRoot%\System32\mstsc.exe /console".

Running the RealPort Setup Wizard is the easiest way to install Digi RealPort devices.

Alternatively, device installation can be automated using the Command Line Interface.

It is also worth noting that Digi RealPort devices may be installed using the Microsoft Add Hardware Wizard and device information (.inf) files that ship with the RealPort software. Please consult Microsoft Windows Help for more information about the Add Hardware Wizard.


Digi RealPort Setup Wizard

Introduction

The Digi RealPort Setup Wizard is the easiest way to install your Digi RealPort device.

The Setup Wizard is part of the same software package as this help document. To run the Setup Wizard, browse to the directory containing the RealPort software package and double-click on the file, Setup.exe.

Welcome Page

The first page of the Wizard is the Welcome page.

If you do not have any devices installed, click "Next >". If you already have one or more devices installed, choose "Add a New Device" and then click "Next >".

Select Device Page

The Setup Wizard searches available networks for RealPort devices and displays those that it finds. Select the device you would like to install from the list and click "Next >".

Your device may not be detected by the Setup Wizard for a variety of reasons:

  • It is off-line;

  • It does not support device discovery (for example, Digi EtherLite, Digi PortServer and Digi PortServer II products);

  • Its discovery responses are blocked by a firewall.

If your network or host computer has firewalls or proxies installed, your device may not be detected during device discovery. If you do not see your device listed in the device discovery list, first verify that your device is powered on and connected to the network.

Next, verify your computer does not have a firewall or proxy installed. If your computer does have a firewall or proxy installed, either install the device manually by selecting <Device not listed> or, if feasible, disable the firewall and/or proxy before installing RealPort.

To install a device that is not discovered by the Setup Wizard, choose <Device not listed> from the bottom of the list and click "Next >". Please note this option will not appear for a few seconds, until after the Setup Wizard finished searching the network for devices.

Describe Device Page

Whether or not you selected a device from the list, you will be directed to the Describe Device Page. If you selected a device from the list on the previous page, you may accept the values on this page and hit "Next >" to install your device, or you may modify values first. Note that if you selected <Device not listed>, you will have to enter at leat the No. of Ports before continuing.

Device Model Name
First, enter the model name of the device you are installing. If you selected a device from the list, this value will be filled in. Otherwise, it is set to its default value, "Standard RealPort Device".

Network Settings
Use: IP, MAC, DNS, or TCP-L
Select one of the four radio buttons, IP, MAC, DNS, or TCP-L, to select how the device is located on the network. Then, enter the device's IP address, MAC address, DNS name, or TCP port to listen on for TCP-L connections. Consult your system administrator or your Digi device documentation if you are unsure which method to use.

For most applications, it is sufficient to use the device's static IP address.

If you are unable to assign your device a static IP address (for instance, your network uses DHCP), you may alternatively specify that the driver locate the remote device using its MAC address or DNS name, or that the driver listen for incoming device connections on a specific TCP port.

If your device is on a private network -- i.e., if your server and device are separated by a NAT -- you will not be able to use a device's IP or MAC address to locate it. Rather, you will need to use the device's DNS address or use TCP-L to listen on a local port for your device to connect to.

If you specify the device's MAC address, the driver will dynamically resolve the IP address of the remote device before connecting to it. Note that this method does not work unless the driver is able to broadcast UDP packets to the network on which the remote device resides -- meaning, the driver most likely cannot resolve the IP addresses of devices across a WAN, since most network switches do not forward UDP broadcasts across the WAN.

If you specify a DNS name, the Realport driver will resolve the IP address of the remote device by looking it up in the local DNS table, specifically by calling the Operating System function, gethostbyname. Your device must be assigned an entry in the network DNS table or this method will not work.

If you enable TCP-L, the RealPort driver will listen on the port you've indicated for incoming device connections. Note that you must also configure your device to initiate such connections -- you will need to supply it the IP address of the machine running the driver and also the TCP port number you configured as the TCP-L port.

Please be aware that the RealPort driver will accept any connection on the TCP-L port. It is therefore recommended that you also enable RealPort Authentication so that only authorized devices may connect.

Default Network Profile
TCP: Typical Settings
This is the most robust and reliable profile and works with most serial applications. The driver and device generate more network traffic using this profile than the other profiles, so this profile is more suited for wired and bandwidth-insensitive networks. You should most likely choose this setting if both the machine running the Windows RealPort driver (i.e., this machine) and the remote device are attached to the same physical network, or if the remote device is accessible across a Wired Ethernet network. You should also test first with this option in most circumstances, and other profiles are less likely to be compatible with all serial applications.

TCP: Modified Read/Write
This setting is similiar to Typical Settings, but changes the way the driver handles reading and writing. For some applications, this may improve serial write performance and decrease incoming and outgoing network usage. For other applications, these settings may cause application errors.

TCP: Less Overhead
This profile configures the RealPort driver to be less chatty and to generate less traffic than the Typical and Modified profiles, at the expense of not being as compatible with all applications. Try this profile if you'd like to reduce the amount of RealPort network traffic, i.e., for byte-conscious or high-latency networks, such as satellite or cellular networks. This setting is not appropriate for very time-sensitive applications but is appropriate for environments where there's a need to reduce network overhead.

TCP: Low Overhead/No Deltas
This profile takes the Less Overhead profile one step further by eliminating keep-alive packets and hardware live event packets. Make sure your application does not need to be notified of hardware line changes before selecting this setting.

UDP: Serial Data only
Configures the network settings for this device to use UDP to send serial data only. This setting will save considerable overhead over TCP, but only serial data is transmitted (i.e., your application cannot set the baud rate using SetCommState). Please configure the line settings on your device separately to match your application.
RealPort TCP Port
Enter the TCP port number of the Digi RealPort Service running on your Digi RealPort Device. Most RealPort devices run the Digi RealPort Service on port 771. (Some devices, however, may use a different number, especially if the device is on a network using Network Address Translation (NAT) and port forwarding.) Consult your system administrator or Digi device documentation if you are unsure what the port number is.

Serial UDP Port
Enter the base UDP port number for inbound and outbound UDP traffic. Most RealPort devices accept UDP data beginning at port 2101 for the first port, port 2102 for the second, and so on. Most devices must be configured to return UDP data to a specific host and port, so you must connect to the device and configure the return address for each port. Consult your system administrator or Digi device documentation for more information.

Wait for COM open request
Wait for a COM port open request before establishing the TCP connection with the device.

Serial Ports
No. Ports
Next, enter the number of physical serial ports on the device you are installing. Please choose a number between 1 and 16. You may specify fewer or greater than the actual number of ports on the device, but you will either not have access to all physical ports (if you specify fewer) or not all your COM ports will map to physical ports (if you specify greater).

Starting COM
The Setup Wizard automatically chooses the first available Windows COM port and maps it to the first physical port on the device. It maps subsequent available COM ports to subsequent physical ports on the device until all ports are assigned COM names.

If you would like to choose a different starting COM port, pick one from the drop-down list.

Device Features
Device Supports: Encryption
Check this box if your Digi RealPort device supports Encrypted RealPort. Checking this box does not enable Encrypted RealPort but merely indicates to the driver that your device supports this option, should you want to enable it. (To enable Encryption, go to the Device Security tab and check the appropriate checkbox. Once enabled, all network traffic between the RealPort driver and remote device will be encrypted using 128-bit AES encryption algorithms.)

Device Supports: Authentication
Check this box if your Digi RealPort device supports RealPort Authentication. Checking this box does not enable RealPort Authentication but merely indicates to the driver that your device supports this option, should you want to enable it. (To enable Authentication, go to the Device Security tab and enter the shared secret. You must enter the same shared secret on the remote device. Once enabled, the remote device rejects all RealPort connections unless the RealPort driver is configured with the same shared secret as the device.)

Click "Finish" when you are ready to install your device.

Installing Digi RealPort Page

This page shows the progress of device installation.

You should not be prompted for anything on this page unless you are installing an "unsigned" RealPort driver.

Unsigned drivers are typically special software builds provided by Digi for specific customers between official driver releases. If you are installing such a build, Windows may prompt you for permission to install the device and each of its COM ports. Please Ok each of these prompts or the driver may not install correctly.

Note that if you downloaded the Digi RealPort driver from the Digi Support Web site or obtained it from a CD-ROM shipped with a RealPort device, the driver is signed and you should not be prompted for confirmation.

Congratulations Page

This page concludes device installation and should indicate successful installation of your Digi RealPort device. Click "Finish" to dismiss the wizard.


Setup Wizard Command Line Interface

Introduction

The Digi RealPort Setup Wizard may be run from the command line. This is useful for automating un-attended driver installations. It also allows you to easily deploy similar driver installations across multiple machines. The command line also makes it easy to "backup" an existing installation by displaying the command line parameters you would run to reinstall the devices exactly the same way.

The Setup Wizard is part of the same software package as this help document. To run the Setup Wizard, open a Windows Command Window and browse to the directory containing the RealPort software package.

To view a comprehensive list of all available command line options, run the following command:

setup /?

A few of the more useful commands are discussed below.

Simple Device Installation Using an I.P. Address

The simplest way to install your device is to use its I.P. address.

E.g., assuming your device has the address, 192.168.0.1, make sure it's connected to the network and then run the command

setup /install /ip=192.168.0.1

The Setup Wizard will query the device to determine how many ports it has and will install them starting with the first available COM port.

If you'd like to specify the first COM port at which to begin installing ports, use the /firstport switch. E.g.,

setup /install /ip=192.168.0.1 /firstport=COM5

If you'd like to install your device without having to connect it to the network, specify the number of ports it has. E.g.,

setup /install /ip=192.168.0.1 /numports=4 /firstport=COM5

Note that if your device is online, the last command may not install the number of ports specified by the /numports option. Rather, the Setup Wizard will query the device and install as many ports as the device says it has. To override this behavior and install /numports ports, either disconnect the device from the network or specify the /skipquery option (see next section).

Use /skipquery to Install Without Querying Device

If you'd like to install your device and override the settings determined by querying the device, tell the Setup Wizard to not query the device by using the /skipquery option. E.g.,

setup /install /ip=192.168.0.1 /numports=1 /firstport=COM5 /skipquery

The last command will install just one COM port, no matter how many ports might exist on the device.

Another use of this option is to install just one or a few ports of a device. For instance, the following command will install one COM port that uses the fourth port of an eight port device:

setup /install /ip=192.168.0.1 /numports=8 /pser=4:COM8 /skipquery

If you look at this device's Property Pages in the Device Manager, the other seven ports appear but are disabled. They can each be enabled and assigned COM ports using the Device Manager, without requiring that the device be reinstalled.

Advanced Device Installation

All of the device and port settings that appear in the Device Manager after a device is installed are specifiable when installing from the command line. Please refer to the command line help for details (i.e., run setup /?).

Update Devices

To update Digi RealPort software and devices, run the command:

setup /update

Remove Devices

There are two ways to remove a device. The first is to specify its I.P. address, e.g.,:

setup /remove /ip=192.168.0.1

The other method for removing a device is to specify its Multi-port serial Instance ID. To determine the Instance ID of installed devices, execute the following command:

setup /show

The Multi-port serial Instance ID is displayed in the left-most column. Determine the Instance ID of the device you'd like to remove and specify it with the /remove command. E.g.,

setup /remove /id=0

Remove All Devices and Digi RealPort software

To remove all devices from your system and simultaneously stop the Digi RealPort driver and associated support services, specify the command, /removeall. E.g.,

setup /removeall

Backup and Restore Device Configurations

If you have installed one or more devices on a machine and wish to have a simple way to reinstall them or to deploy the same configuration to another machine, run the /examine command. E.g.,

setup /examine

The Setup Wizard will display a complete installation command for each of the devices installed on the machine. Use the displayed installation commands when reinstalling devices or when deploying devices on another machine.

For instance, the easiest way to deploy devices on multiple machines is to first install the devices on one machine using the Digi RealPort Setup Wizard GUI (not the command line) by double-clicking setup.exe (if you run setup.exe from the command line, it won't display the GUI). Follow the prompts to select and install your device(s). After the device(s) are installed, go to the Device Manager and open each device's Property Page and configure the devices and ports how you would like them configured. Finally, open a Command Window and run the /examine command. The Setup Wizard will display the command line parameters you can execute from the command prompt that will result in the same installation you achieved by using the GUI.

Change Device Configurations

The /change command provides a simple mechanism to change the characteristics of an installed device using the Command Line rather than the Device Manager. This is useful for scripting common activities. E.g., this command will change the I.P. address of an installed device:

setup /change /id=0 /newip=192.168.1.1 /skipquery

See above for determining a device's Instance ID using the /show command. Note also that /skipquery is usually be specified with the /change command, otherwise the Setup Wizard will query the device and revert some settings back to those specified by the device.


Configuring Digi RealPort for Windows

Digi RealPort for Windows Software is configured from Windows Device Manager.

There are many ways to access Device Manager:

  • Open System Properties by going to the Start Menu > Control Panel > System. Next, click the tab marked "Hardware" and then the button entitled, "Device Manager".

  • A shortcut to opening System Properties is to type the "Windows" key and the "Break" key at the same time.

  • Instead of opening System Properties, one can access Device Manager from Computer Management, which is accessible from the Administrative Tools directory in the Start menu. Once open, click "Device Manager" on the left-hand side of the Computer Management window.

  • A shortcut to opening Computer Management is to right-click on My Computer and choose Manage.

Once Device Manager is open, find your device:
  1. Expand the category, Multi-port serial adapters.

  2. Locate your device in the list using its name or IP address.

  3. Double-click your device in the list or right-click on it and choose "Properties".

  4. Click the tab marked "Advanced" to view basic information about your device.

  5. Click the button marked "Properties..." to configure your device.


Device Configuration

Use the Device Properties tab to assign your device a name and a description and to easily change the COM names of its ports.

Use the Device Network tab to identify your device's I.P. address and network ports. You can also access the Device Discovery Wizard to automatically discover your device's settings.

Use the Device Security tab to enable or disable encryption and set authentication settings.

Use the Device Advanced tab to configure other properties of your Digi RealPort driver, such as the keep-alive mechanism.

Use the Device Watchdog tab to configure the Keep alive and External Application settings.


Device Basic Settings

Device Name

Normally, the name of the device is the name of the product followed by its I.P. address in parentheses.

E.g., "Digi Connect ME (192.168.0.123)"

To replace the I.P. address with text of your choice, enter a short name here; it will be displayed in the Device Manager in place of the I.P. address.

E.g., "Digi Connect ME (My first device)"

Device Description

The device description can be used any way you would like to store additional information about the device. It is displayed on the Advanced tab of the Device Manager Property Page for your device.

Alternative Friendly Name Display Format

Enabling this causes the name displayed in the Device Manager to use the User Name rather than the device product name.

E.g., "My first device (192.168.0.123)"

Rename Ports...

Click the Rename Ports... button to change all the COM numbers of a device's ports. A dialog will pop up with a drop-down list of available COM ports. From the list, choose a COM port number with which to begin renumbering.

Factory Defaults...

Opens the Factory Defaults dialog, which allows you to choose what settings to reset.

Help

Opens this help document.


Device Network Settings

Device Network Location

Select one of the four radio buttons, IP Address, MAC Addr., Hostname, or Other, to choose how the driver should try to locate your device on the network. Each method is discussed below. Please consult your system administrator if you are unsure which method to use.

For most applications, it is sufficient to use the device's static IP address.

If you are unable to assign your device a static IP address (for instance, your network uses DHCP), you may alternatively specify that the driver locate the remote device using its MAC address or DNS name.

However, if your device is on a private network separate from your server (for instance, your device accesses the Internet through a NAT server and cannot be connected to from the outside, such that your server cannot "see" your device), you will not be able to use your device's IP address, MAC address, or DNS hostname to locate it. Instead, you will have to use TCP-Listen, whereby the server will listen on a local port until your device connects.

If you specify the device's MAC address, the driver will dynamically resolve the IP address of the remote device before connecting to it. Note that this method does not work unless the driver is able to broadcast UDP packets to the network on which the remote device resides -- meaning, the driver likely cannot resolve the IP addresses of devices across a WAN, since most network switches do not forward UDP broadcasts across the WAN.

If you specify a DNS name, the Realport driver will resolve the IP address of the remote device by looking it up in the local DNS table, specifically by calling the Operating System function, gethostbyname. Your device must be assigned an entry in the network DNS table or this method will not work.

If you enable TCP-Listen (choose the radio button entitled, "Other", and then choose "TCP-Listen" from the drop down menu; click the "Settings..." button to configure the port number on which to listen), the RealPort driver will listen on the port you've indicated for incoming device connections. Note that you must also configure your device to initiate such connections -- you will need to supply it the IP address of the machine running the driver and also the TCP port number you configured as the TCP-L port.

Please be aware that the RealPort driver will accept any connection on the TCP-L port. It is therefore recommended that you also enable RealPort Authentication so that only authorized devices may connect.

Consult your system administrator or your Digi device documentation if you are unsure which method to use.

IP Address

An example I.P. address is "192.168.0.1".

MAC Address

An example MAC address is "00:40:9D:01:23:45".

Hostname

An example DNS hostname is "mydevice.mycompany.com".

TCP-Listen Port

An example TCP-L port is "8711".

Browse

Alternatively, you can instead search for your device using the Device Discovery Wizard. Click on the Browse... button to use the wizard.

Settings...

Depending on the network translation method chosen from the "Other" drop down menu, this will bring up a dialog to configure the chosen option.

Currently, the only available "Other" method is TCP-Listen; clicking "Settings..." opens the Device-Initiated RealPort Settings dialog.

Device Service Ports

RealPort TCP Port

This is the TCP port of the RealPort service running on the remote device. The default port number is 771. This value should match the value configured on your device.

Connection Settings

Click on the Connection Settings... button to control how the driver connects to the device. Opens the Connection Settings dialog.

These controls determine how RealPort attempts to open the network connection to the remove device. The settings will affect the number and frequency of network packets and bytes the driver generates when attempting to connect to the remote device.


Device-Initiated RealPort Settings

TCP-Listen Mode

If a device is on a private network, it can initiate connections out to the Internet, but machines outside the private network cannot initiate connections back to the device. This is because such private networks use Network Address Translation, or NAT, to reuse IP addresses, which precludes device on the private network from being publically addressable.

To overcome this limitation, one should configure the Digi RealPort driver to listen for incoming device connections, rather than having it initiate device connections itself.

Please be aware that, by default, Digi RealPort configured for TCP-Listen will accept any connection on the TCP-Listen port. As such, to prevent unauthorized usage of this service, it is recommended that you enable RealPort Authentication to restrict access to the TCP-Listen service.

Note that TCP-Listen (and RealPort Authentication, if you use it) must be configured on both the server (the machine running the Digi RealPort driver) and your remote Digi device.

TCP-Listen Port

Set the TCP port number that the driver will listen on for incoming device connections. Configure your remote device with the same port number.


Device Network Connection Settings

TCP Socket Behavior

These controls determine how RealPort attempts to open the network connection to the remote device. The settings will affect the number and frequency of network packets and bytes the driver generates when attempting to connect to the remote device.

Connect Timeout

Connect Timeout determines the maximum time per connection attempt to wait from a connection response from the remote device. If 0, the default Windows value is used. If the Nagle algorithm is disabled (see the Device Advanced tab), each connection attempt will only consist of one network packet, otherwise each attempt could consist of multiple (generally at most three) packets. In most cases, if Nagle is enabled and this value is 0, Windows will attempt three times to reach the remote device. The first attempt will time-out after 3 seconds, the second after 6 seconds, and the third after 12 seconds, so the complete connection attempt will take at most 21 seconds. Note that the Nagle algorithm will use longer time-outs on less responsive networks.

Retry Frequency, Retry Count and Offline Frequency

When RealPort is started, when a COM port is opened, or when RealPort loses a network connection to a device, it attempts to re-open that connection to the remote device. The three settings, Retry Frequency, Retry Count, and Offline Frequency, dictate often how RealPort tries to re-open the connection.

RealPort will try up to Retry Count times every Retry Frequency milliseconds to open the connection. If RealPort tries the same number of times as Retry Count without success, it then tries every Offline Frequency milliseconds to open the connection.

In this way, users can control how aggressively the driver attempts to connect to the remote device. The more aggressively the driver tries, the more network packets and bytes will be sent. It is suggested that users utilizing cellular or satellite networks -- or users who otherwise have limited bandwidth -- set the reconnection behavior less aggressively.

Note that Connect Timeout controls how long the TCP stack waits for a connection response from the remote device. Retry Frequeny, Retry Count, and Offline Frequency control how often the driver asks the TCP stack to try opening that connection. Furthermore, the driver considers the time between connection attempts to be the time between calls to TCP stack (and not when the call returns). I.e., Retry Frequency is not compounded by the value of Connect Timeout, but is independent of it -- if the attempt to open the network connection takes Connect Timeout milliseconds and Retry Frequency is less than that, the driver will immediately attempt another connection as soon as the first one returns (assuming, of course, the first one fails).

Retry Frequency
Retry Frequency specifies how often to try to connect to the remote device, in milliseconds, when first trying to open the connection.

Retry Count
Retry Count specifies the number of times to try to connect to the remote device every Retry Frequency milliseconds before backing off and trying evert Offline Frequency milliseconds.

Offline Frequency
Offline Frequency specifies how often to try to connect to the remote device, once RealPort has already tried as many times as specified by Retry Count.

Fail COM Open if Retry Frequency not elapsed

The reconnection throttle controls set above -- namely, Retry Frequency, Retry Count, and Offline Frequency -- normally only apply when the driver is reconnecting an interrupted connection for an already-opened port. If you would also like the driver to honor these controls whenever an application opens a COM port (i.e., via CreateFile), enable this feature.

If this feature is enabled and the next reconnect is more than 5 seconds away, CreateFile returns a failure.

For example, if you set Retry Frequency to 10 seconds and then open a port and close it, if you try to re-open that port before 10 seconds has elapsed since you first opened the port, the driver will fail your attempt to open the port.

If the next reconnection attempt is less than 5 seconds away, however, the driver will pend the request until after trying to reconnect to the remote device and trying to open the port.

If this feature is disabled and the driver is not already connected to the remote the device, the driver will always try connecting to the device whenever a COM port is opened.

Wait for COM open request before connecting

Normally, RealPort opens the network connection to the remote device when RealPort starts. Enable this box if RealPort should only start and maintain the network connection when an application is accessing COM ports.

UDP Socket Behavior

These controls determine how RealPort handles UDP connections.

UDP IP Resolution Scheme

If connecting via MAC or DNS, the IP address can be resolved just once, periodically, or for every packet sent.

Resolve on startup: the MAC or DNS is resolved when the RealPort network service starts.

Resolve if no RX for n secs.: If n seconds elapse without any receive data, the IP address will be re-resolved from the MAC or DNS.

Resolve for every packet sent: before any UDP data is transmitted, the MAC or DNS address is resolved.

Disable device detection warnings

If enabled, the Wizard will never query the network for the presence of the remote device. The Wizard will normally query for the device when a new network address (IP, MAC, or DNS) is entered. To converse network resources when using the RealPort Setup Wizard or Device Manager plugin, enable this option.

Default

Click to restore settings on this page to their default values.


Device Security Settings

Network Security

Authentication Secret

If you set an authentication secret on your device, enter that same value here. When you try to open a port, the driver and device will securely exchange keys to ensure that each side knows the "shared secret". If the values do not match, you will not be allowed to open the port.

This feature is enabled only if the remote RealPort device supports Authenticated RealPort.

Encrypt Network Traffic

Use this feature to encrypt network data sent between the RealPort driver and the remote device. By default, data is transmitted as plaintext across the network.

This feature is enabled only if the remote RealPort device supports Encrypted RealPort.

The Digi RealPort Network Service is automatically installed by the Digi RealPort Setup Wizard when you install a device. It encrypts data using TLS v1.0 and employs a 128-bit AES cipher.

TCP Port For Encrypted Traffic

Use this field to change the TCP port that the RealPort driver uses to establish an Encrypted RealPort session with the remote device. The default port is 1027.

This checkbox is not displayed if your device does not support Encrypted RealPort. See the preceding section, Encrypt Network Traffic, for more information.

Query Device

Send Query...

If your device doesn't support one or both of the security features, authentication or encryption, you may need to update its firmware. Visit http://www.digi.com/support/ and look for Firmware Updates. Read the release notes of the newer firmware and look for an indication that the firmware supports Encrypted RealPort. Follow the directions to update the firmware.

After you have updated firmware, click the Send Query... button. The driver will query the device to see what new features it supports.


Device Advanced Settings

Advanced Network Settings

Disable TCP Nagle Algorithm

If enabled, disables the TCP Nagle algorithm.

The TCP Nagle algorithm is implemented by most modern TCP/IP stacks and determines when and how often to retransmit unacknowledged network packets. Unless you are familiar with TCP/IP and Nagle, it is recommeded that you leave Nagle enabled (and this checkbox unchecked).

Use Event Viewer to Record Significant Port Events

If this feature is enabled and a port cannot be opened by an application, the reason why the port cannot be opened is logged to the Windows System Event Log (accessible from the Device Manager).


Device Watchdog Settings

Keep Alive Settings

Send Keep Alive Packets

This is a mechanism that allows the Digi RealPort driver to periodically monitor its network connection with the remote RealPort device.

Sending keep-alive packets may make the driver more responsive to serial requests by allowing the driver to detect network disconnects and network problems during periods of serial inactivity. In other words, the driver may not discover network problems until it tries to send data to the remote device, such that, if keep-alive is not enabled, the driver will not learn about network disconnects until it tries to send serial data. Detecting and repairing a lost connection may take a number of seconds and will delay the time it takes to transmit serial data.

Note that the driver sends one-byte RealPort protocol messages to implemented Keep Alive packets; it does not use the genereic TCP/IP Keep Alive mechanism.

If keep-alive is enabled, the driver periodically sends a keep-alive packet to the device. If TCP/IP does not receive an acknowledgement from the device, it marks the connection as broken and notifies the RealPort driver.

If the network connection is broken, the driver logs this information to the Event Viewer. Next, it tries to establish a new connection. The driver will continue to try to establish a new connection until it succeeds, until the driver is disabled, or until keep-alive is turned off.

Once a new network session is established, the driver logs another event to the Event Viewer to inform you that a new network session has been established with the device.

If keep-alive is not enabled, the driver will still detect and log network events, but only when a port is open and there is serial activity.

Furthermore, some cellular connections will be torn down after a period of network inactivity. By configuring the driver to send keep-alive packets, you can ensure that the cellular link will not be torn down.

To enable the keep-alive mechanism, check the box entitled, "Send Keep Alive Packets".

Inactivity Timeout (msec.)

The default driver behavior is to send a keep-alive packet after 3 seconds of network inactivity. You may modify the frequency by entering a new value in the edit box.

Send only when ports are open

The driver normally only sends keep-alive packets if one or more ports are open by an application. To always send keep-alive packets -- even when no ports are open or active -- uncheck the box, "Send only when ports are open". Sending keep-alives all the time may make opening ports quicker by ensuring that a connection always exists to the device.

External Application Execution

Execute Command Whenever Connection Is Active

When enabled, this feature configures the driver service to execute a Windows command whenever the network session to the device is established.

If specified in the command text, the string, "%ip%", will be substituted with the actual device I.P. address.

Please enclose the name of the executable in quotes if the path to the executable contains spaces.

Note also that it may be necessary to configure the service to allow it to interact with the desktop. Otherwise, the command may not execute properly. On the "Log On" tab of the Digi RealPort Network Service Properties page, enable the feature, "Allow service to interact with desktop".

Only Execute If Device I.P. Address Has Changed

Configures the driver service to only execute the command when the first network session is established and when the device I.P. address changes.

Frequency (msec.)

Configures the driver to execute the command this often wheneven the connection is active. If disabled, the driver only executes the command once, when the new network connection is established.


Port Configuration

Use the Port Properties tab to assign your ports their own names and descriptions.

Use the Port Serial tab to set the default printer settings for your ports, and to change COM names.

Use the Port Advanced tab to modify how your ports interact with user applications.

Use the Port TCP tab to modify how your ports interact with the network when using TCP.

Use the Port UDP tab to modify how your ports interact with the network when using UDP.


Port Basic Settings

Port Name

Normally, the name of the port is displayed as the name of the product followed by the logical port number and the port's COM name.

E.g., "Digi Connect ME Port 1 (COM5)"

To replace the COM name with text of your choosing, enter a brief name here; it will be displayed in the Device Manager in place of the COM name.

E.g., "Digi Connect ME Port 1 (My first port)"

Port Description

The port description can be used any way you would like to store additional information about the port. It is only displayed on the Port Properties page.

Port Network Profile

The Port Network Profile determines how a port is configured to use the network.

Choose a new network profile to reset the settings for a port to a match a particular profile. Then, if needed, tweak the settings to achieve the desired port behavior.

TCP: Typical Settings

This is the most robust and reliable profile and works with most serial applications. The driver and device generate more network traffic using this profile than the other profiles, so this profile is more suited for wired and bandwidth-insensitive networks. You should most likely choose this setting if both the machine running the Windows RealPort driver (i.e., this machine) and the remote device are attached to the same physical network, or if the remote device is accessible across a Wired Ethernet network. You should also test first with this option in most circumstances, and other profiles are less likely to be compatible with all serial applications.

TCP: Modified Read/Write

This setting is similiar to Typical Settings, but changes the way the driver handles reading and writing. For some applications, this may improve serial write performance and decrease incoming and outgoing network usage. For other applications, these settings may cause application errors.

TCP: Less Overhead

This profile configures the RealPort driver to be less chatty and to generate less traffic than the Typical and Modified profiles, at the expense of not being as compatible with all applications. Try this profile if you'd like to reduce the amount of RealPort network traffic, i.e., for byte-conscious or high-latency networks, such as satellite or cellular networks. This setting is not appropriate for very time-sensitive applications but is appropriate for environments where there's a need to reduce network overhead.

TCP: Low Overhead/No Events

This profile takes the Less Overhead profile one step further by eliminating keep-alive packets and hardware live event packets. Make sure your application does not need to be notified of hardware line changes before selecting this setting.

UDP: Serial Data only

Configures the network settings for this device to use UDP to send serial data only. This setting will save considerable overhead over TCP, but only serial data is transmitted (i.e., your application cannot set the baud rate using SetCommState). Please configure the line settings on your device separately to match your application.

Change...

Opens the Set Port Profile dialog.

Port Status

The Port Status shows the state of the local COM port and network resources.

The Local COM status indiates if the local COM port is Closed or open. If the COM port is open, the Wizard indicates which application has the port open.

If the Network Profile is set to TCP, the second status is the Device Port, which is the remote device port to which the driver will attempt to connect. If the driver has successfully connected to the remote device port, the status shows Acquired.

If the Network Profile is set to UDP, the second status is the UDP RX Port, which is the local port on which the driver is listening for incoming UDP serial data. If the driver has successfully bound to this port, the status shows Connected.


Port Serial Settings

COM Port Number

To change a port's COM name, select a different one from the drop-down list of available COM ports.

Line Settings

The line settings are used by the Windows Print Spooler to determine the default line settings of the port when printing. The line settings include baud rate, number of data bits, type of parity, number of stop bits, and type of flow control.

To change the default print spooler settings, adjust the Baud Rate, Data Bits, Parity, Stop Bits, and Flow Control settings using the drop-down lists.

Note that these settings are not the default settings when the serial port is opened. Rather, these settings are stored in the Registry so that some applications -- like the Print Spooler -- can read them and use them as defaults. (See the Windows communication functions, GetDefaultCommConfig and SetDefaultCommConfig, in the Windows SDK or MSDN Library.)

Copy Settings...

Opens a dialog so you can copy this port's settings to one or more other ports.


Port Advanced Settings

Driver Settings

Do Not Scan Modems on Boot (Serenum SkipEnumerations)

Enable this feature to stop Serenum from opening the port to scan for modems and attached devices. Otherwise, Serenum scans for modems when Windows boots or whenever the device is disabled and then enabled.

Use Event Viewer to Record Significant Port Events

If this feature is enabled and a port cannot be opened by an application, the reason why the port cannot be opened is logged to the Windows System Event Log.

Application Settings

Always Grant Port Open Requests

Turn on this feature if you want the RealPort driver to always grant open requests, even if the driver cannot communicate with the remote device at the time of the open, or even if the remote device rejects the open request.

By default, the driver will only grant an open request if it can communicate with the remote device, and only if the remote device okays the open request. For instance, if you disconnect the remote device from the network and then try to open one of its ports, the RealPort driver will reject the open request, and your application will not be able to open the port until the device is back on-line.

If this option is enabled, note that the RealPort driver may grant an open request even if the physical port on the remote device is in use by another application. The RealPort driver will continue to try to claim that port, but there is no guarantee that it will ever succeed. To the local application, it has opened the port, and it can read and write data, but the data will not really be written until the RealPort driver can claim the physical port, and the local application will not see any read data until that time, either.

Guarantee Non-blocking Serial Calls (excl. WriteFile)

Some Win32 communication functions block while the driver confirms that the device has completed a task (e.g., EscapeCommFunction, SetCommState). This wait is normally on the order of milliseconds but may be delayed by seconds or minutes if TCP is retransmitting packets. I.e., every time a user application calls a Win32 communication function, that thread blocks until the driver completes the request. Check this box if you want the driver to guarantee that Win32 communication function calls will not block.

For instance, if an application calls EscapeCommFunction and specifies CLRDTR, EscapeCommFunction blocks until RealPort confirms that the remote device has lowered DTR. While in most circumstances the blocking only takes a matter of milliseconds, if the network connection were to be severed while this call was pending, an application might block for up to thirty seconds while the Windows network stack tries retransmitting the unacknowledged network packets. To avoid this situation, check this box; an application's serial comm API calls will never block, but some calls may return to the application before the actual call is fully processed.

Note that this feature does not apply to WriteFile calls. To specify that WriteFile calls not block, enable the option, Complete Write Requests Immed., found on the Port TCP tab.

Message Settings...

Opens the Message Coalescence Settings dialog. Use these settings to have the driver accumulate complete messages before delivering read bytes to the application.

Custom Settings...

Opens the Advanced Custom Settings Dialog for the port. Custom-application RealPort settings are used by applications written specifically for RealPort.

Copy Settings...

Opens a dialog so you can copy this port's settings to one or more other ports.


Incoming Messages Settings

Driver Coalescence -- Simple Message Intelligence

Enabling Driver Coalescence causes the driver to accumulate received data before delivering it to the application. This can be useful for time-sensitive legacy applications running across wide-area networks.

Note that you need to know details about the serial protocol being used by the application and the remote serial device to properly configure the driver for message coalescence.

Off

This setting disables message coalescence. The driver indicates received data to the application as soon as it reads it from the TCP/IP stream.

Messages end with this byte

This setting enables message coalescence using an end-of-message delimiter. The driver will not reveal received bytes to the application until the indicated byte is seen in the serial stream.

Messages start with this byte

This setting enables message coalescence using a beginning-of-message indicator. This is the most complicated form of method coalescence.

Until the start byte is seen, the driver indicates received bytes to the application as soon as they arrive, just as though message coalescence were disabled.

Upon receipt of the beginning-of-message indicator, however, the driver will coalesce bytes based on two other settings, the position of the length byte and the number of overhead bytes.

... the position of the length byte is

Messages with beginning delimiters but not ending delimiters most likely are either a fixed length or include the length of the message embedded somewhere in the message.

If the length of the message is embedded within the message, set this value to indicate the position of the length byte in relation to the start byte. For instance, if the beginning-of-message byte is immediately followed by the length byte, set this value to 1.

Set this value to 0 if there is no length byte in the message.

... and there are this many other bytes

If the message is fixed-length or there are additional bytes not indicated by the length byte, specify that count here.

Consider again the previous example, in which the length byte immediately follows the beginning-of-message delimiter. If the delimiter byte is not included in the length byte and there are no other bytes not accounted for by the length byte, set this value to 1.


Port Custom Settings

Custom-application RealPort settings are generally used by applications written specifically for RealPort. These features are not guaranteed to be supported by all applications.

Always Use RTS Toggle for Flow Control

Specifies that the port always use RTS Toggle flow control, whether or not the application calls SetCommState.

Use Serial API To Alert Application If Device Goes Off-line

***************************************************************
*** WARNING!! *************************************************
This feature is for use only by custom applications. Enabling
this feature will likely cause an application to behave
erratically, unless it has been written exclusively to use this
feature. Please read these instructions carefully to learn how
use this feature with your custom application.
***************************************************************

The RealPort driver supports two methods to handle Wide Area Network (WAN) errors, such as those generated when the RealPort driver loses its TCP/IP session with the remote RealPort device.

By default, this feature is disabled and the RealPort driver seamlessly and transparently handles any and all network errors. The most common network error is that the driver loses its TCP/IP session with the remote RealPort device, either because the RealPort device is unreachable due to general network failures or because the RealPort device is rebooted or powered off.

In the event that the RealPort driver loses its TCP/IP session with the remote RealPort device, the driver will periodically attempt to reestablish a new connection with the device. The driver will also simulate a loss of hardware flow control lines by lowering each of the following signals -- DCD, DSR, and CTS. It will also simulate receipt of an Xoff character, if software flow control is being used.

In this mode, client applications will not and cannot detect network errors. Client applications are free to continue reading from and writing to RealPort ports, and to continue using the ports as they otherwise normally would. In this way, network errors are handled transparently from the client application.

However, it is sometimes useful for a client to know that a remote RealPort device is unreachable because the TCP/IP session is dropped. In this case, you can enable this feature, and the RealPort driver will then communicate network errors to the client application when the network is unreachable.

If this feature is enabled, when the network connection is dropped and a client initiates a read or a write (ReadFile or WriteFile request), the driver will immediately complete the operation and return the error, ERROR_NETWORK_UNREACHABLE. The driver will likewise complete all serial communication calls with the same response (i.e., ClearCommError, PurgeComm, SetCommState, etc.). A client application can be specifically written to recognize this error code and to respond accordingly, such as by logging the error to a file. The driver will continue to return this error code until it is able to reestablish a network connection with the remote RealPort device, at which point the driver will resume normal processing of read, write, and serial requests.


Port TCP Settings

TCP Transport Settings

Complete Write Requests Immed. (Don't block on WriteFile)

If this field is checked, the driver will confirm completion of each client WriteFile request as soon as serial data is queued for transmittal. Unchecking this field (the default) causes the driver to wait to complete each WriteFile until the data has been electrically transmitted out the port.

This option may cause an application to behave unexpectedly. For instance, some applications need to know when data has been physically written, and by telling the application that data has been written before it is actually written may confuse the application or cause it to fail.

Conversely, some applications have strict timing requirements and may fail or timeout often if this option is not enabled.

This feature is disabled by default. Please thoroughly test your application if you plan to operate with this feature enabled.

Discard Writes if Device Buffer Full (else WriteFile blocks)

The Complete Write Requests Immed. option is useful if the application isn't sending larger (i.e., > 4 Kb) blocks of data. Otherwise, the driver may exceed the network data window, in which case any outgoing data will have to be pended or dropped.

By default, this option is off and the driver will block data if the network cannot handle any more data, which will block the WriteFile call that initiated the data. Conversely, if this option is on, the driver will just toss the data and complete the WriteFile request.

Most applications can benefit from Complete Write Requests Immed. without needing to enable this option.

Signal TXE Immediately (WaitCommEvent's EV_TXEMPTY)

This feature is similar to the last option, Complete Write Requests Immed., but it applies to signaling the SERIAL_EV_TXEMPTY event. A client application can ask to be signaled when the transmit buffer is drained by first calling SetCommMask and then waiting for or checking the event by calling WaitCommEvent.

Checking this field means that the driver signals SERIAL_EV_TXEMPTY as soon as serial data is queued to be transmitted. If this field is unchecked (the default), the driver will wait to signal SERIAL_EV_TXEMPTY until it has detected that all serial bytes have been electrically transmitted and there is no more serial data queued to be sent.

As with the last option, this option may cause an application to behave unexpectedly. Please thoroughly test your application if you plan to operate with this feature enabled.

Verify all data sent on close (may block CloseHandle)

Specifies that RealPort should pend completion of an application's request to close the COM port until it verifies that all write data has been transmitted.

Timeout if no data movement for
Specifies how long RealPort should wait to verify that all write data has been transmitted once an application has requested to close the COM port. Note that a call to CloseHandle may block for as long as the value specified here.

This port is being shared (don't lower lines on close)

Check this box if the port on the device is being shared by other applications (i.e., Port Sharing is enabled on the remote device). Normally, when an application closes a COM port, RealPort lowers the hardware lines for that port. This can cause problems if the port is being shared and still in use by other applications. Enabling this feature causes the RealPort driver to not lower hardware lines when a COM port is closed.

Ignore line and serial settings

The remote device normally sends changes in hardware lines to the driver. To reduce network traffic, enable this feature. Note that some applications need to know about line events and may not work properly if this feature is enabled.

Ignore Settings...
Click the Ignore Settings... button to choose which line and serial settings to surpress.

Adjust serial data packetization

Data Notification...
Opens the Data Notification Settings dialog.

Copy Settings...

Opens a dialog so you can copy this port's settings to one or more other ports.


Adjust Port Network Profile

Device Receive Data and Transmit Notification Triggers

Receive triggers determine when the remote device delivers incoming data to the driver. In other words, the remote device will buffer incoming serial data until a certain condition is met before it sends a TCP/IP packet to the driver. The condition depends on how many bytes are received and how long has passed since the reception of the last byte.

Note that decreasing the number of packets sent from the remote device to the driver may decrease serial throughput and increase serial latency.

The following settings are not mutually exclusive; a device may send a TCP/IP packet if triggered by either condition.

Hold data until this many bytes are received

The remote device will send a TCP/IP packet containing serial data once this many or more incoming serial bytes are received.

Or until this many msec pass since last byte

The remote device will send a TCP/IP packet containing serial data once a byte has been received and then this many milliseconds elapse before receipt of the next byte. This setting is similar to a serial inter-character timeout.

Transmit triggers determine when the device notifies the driver that outgoing data has been sent.

Having the device notify the driver more often ensures better serial throughput when sending lots of data.

These settings have less impact on serial latency than do the receive data triggers, but setting a transmit notification trigger incorrectly may still result in decreased throughput and increased latency.

Notify driver after sending this many bytes

The device will notify the driver that it has transmitted serial data once it has sent this many or more bytes.

Note that the device has a finite serial buffer with which to receive outgoing serial data from the driver. Should this buffer fill, or should the driver think this buffer is full because the device has not sent a transmit notification, the driver will stop sending data to the device and may eventually flow-control the application. As such, be sure not to set this value too high for your application.

Or this many msec pass since last update

The device will notify the driver that it has transmitted serial data once this many milliseconds elapse since the last transmit notification was sent and outgoing serial data has been transmitted since then.

Driver Receive Notification Trigger

Set this trigger to control when the driver notifies the device that it has consumed incoming data.

Like transmit notifications, the driver has to tell the remote device once it has consumed incoming serial data so that the device can pass along more data. If the driver does not update the device often enough, the serial data may be throttled.

Notify device after receiving this many bytes

The driver will notify the device that it has consumed incoming serial data once it has received this many bytes.


Port TCP Settings

Port UDP Settings

UDP Transport Settings

Local (RX) Port Number

Enter the local port number on which the driver will listen for data from the remote device. Configure this same value for the port on the device, on the UDP Sockets configuration page for the port.

Device (TX) Port Number

Enter the remote port number to which the driver will send data to the remote device. This value corresponds to the Base Socket value configured on the device, under the Advanced Network Settings section.

Slave/responder mode (Reply to last incoming IP/SRC)

Uses the source port of the last-received UDP packet as the destination IP address and port for outgoing packets. If left unchecked, the Base UDP port is used to determine the destination port for outgoing packets.

Data Collection Timeout

Enter the length of time, in milliseconds, that the driver should wait after having last received outgoing serial data from the application before sending the data to the device. Adjust this setting if you would like to control how the driver coalesces data into each UDP packets.

Maximum Packet Size

Enter the maximum numbers of bytes that the driver will coalesce before sending a UDP packet. This setting complements the data collection timeout.

Copy Settings...

Opens a dialog so you can copy this port's settings to one or more other ports.


Digi RealPort Driver Configuration

Introduction

There are two methods to configure Digi RealPort software.

One method is to run the Digi RealPort Setup Wizard GUI to install Digi RealPort software and devices, and then to open the Device Manager to configure the installation.

Another method is to use the Digi RealPort Setup Wizard CLI to install Digi RealPort software and devices. With the CLI, the user can configure all device settings during installation, without being required to manually configure options using the Device Manager.

The GUI method is obviously the easier of the two methods for installing RealPort software and devices, especially for users less familiar with each of the configuration options -- namely, there are over two dozen configurable options, and translating custom option settings into a Setup Wizard CLI command is a daunting task.

Fortunately, one can examine an existing installation with the Setup Wizard CLI to produce an appropriate CLI installation command.

For instance, suppose a user has 100 Digi devices for 100 different servers, and the user wishes to configure each server the same (i.e., suppose each server/device pair will be on its own private subnet, that each Digi device will be assigned the same private I.P. address, and that each server will be configured to use the same set of COM port numbers).

To make deployment easy, the user should first use the Setup Wizard GUI to install one device on one server and then to use the Device Manager to configure that device. Next, the user should verify that his or her application runs as expected. Finally, the user can generate a CLI command that can be pushed to each of the remaining 99 machines, eliminating the need for a user to run the Setup Wizard GUI 99 more times on 99 different machines.

Thus, if a user has installed one or more devices on a machine and wishes to have a simple way to reinstall that environment or to deploy it to another, she can run the CLI command, /examine. E.g.,

setup /examine

The Setup Wizard will examine the current RealPort installation and will generate CLI commands to be used to replicate the existing installation.

Configuration Options

Every configurable option that can be set using the Device Manager can also be specified when installing devices using the Setup Wizard CLI, as demonstrated by the /examine command.

To view a complete list of configurable options, run the Setup Wizard CLI /? command:

setup /?

The output of this command is reprinted below. To help understand which CLI option corresponds to which GUI elements, each of the commands below links to the corresponding GUI control documentation.

Commands
Device Setup Commands
/install | Install RealPort device
/remove | Remove RealPort device
/change | Change RealPort device configuration

Software Setup Commands
/update | Update RealPort software
/removeall | Remove RealPort software and all devices

Device Information Commands
/count | Show count of installed devices
/details | Show details of installed devices
/show | Show fewer details of installed devices
/showcoms | Show details of configured COM ports
/examine | Show setup command for current installation
/help or /? | Display Usage Information

Device Setup Parameters
Required Device or Port Identifier (Specify At Least One)
/ip=a.b.c.d | Device IP address
/mac=00:40:9D:... | Device MAC address
/host=a.b.com | Device DNS hostname
/tcplport=n | TCP-Listen port
/id=n | Device Instance ID (/remove, /change only)
/com=n | Port COM Number (/change only, with /likecom)

Network Location Qualifier (Optional, Specify Only One)
/resolvemac | Always use MAC address to locate device
/resolvedns | Always use DNS hostname to locate device
/resolvetcpl | Listen on local TCP port for device connection

Optional Device or Port Reference (/change only)
/likeid=n | Mimic device with instance id "n"
/likecom=n | Number of COM Port to emulate (use with /com)
/newip=a.b.c.d | New IP address

Simple Port Configuration Parameters (for /install, /change)
/numports=n | Number of COM ports to install (default: no. of ports reported by device or 1)
/firstport=COMn | Name of first COM port (default: first avail.)

Advanced Port Configuration Parameters (for /install, /change)

Each of these may be specified more than once

/pname=1,2-3,*:"abc"
User-specified Port Name
/pdesc=1,2-3,*:"abc"
User-specified Port Description

/ppro=1,2-3,*:{"typical"|"modified"|"less-over"|"low-over"}
Configure port for specific network profile (Overrides /netprofile, if specified; also overrides select /p* port options)

/pser=1,2-3,*:COMx[,Printer-Settings]
Port Serial Settings
Printer-Settings: "Baud,Bytesize,Parity,Stopbits[,Flow]" (E.g., "9600,8,n,1")
Baud | any number from 1 to 921600
Bytesize | any number from 5 to 8
Parity | "n" (none), "e" (even), "o" (odd) "m" (mark), "s" (space)
Stopbits | 1, 1.5, 2
Flow | "" (none), "p" (h/w), "x" (s/w)

/padv=1,2-3,*:[{+|-}{e|s|o|b},...]
Basic Port Settings
e | Skip Enumerations (Do not detect modems)
s | Silent Events (Do not log to Event Viewer)
o | Always Grant Port Open Requests
b | Never Cause Appl. Serial Call to Block

/pmsgs=1,2-3,*:{off|eom|beg},eom,beg,lenpos,extra
Port Message Coalescence Settings

/pcust=1,2-3,*:{+|-}a,{+|-}r
Port Custom Application Settings
a | Alert Application if Device Goes Off-line
r | Always Use RTS Toggle for Flow Control

/ptcp=1,2-3,*:[{+|-}{c|t|i|b|s},...],drainonclose
Port TCP Transport Settings
c | Complete Write Requests Immediately
t | Signal SERIAL_EV_TXEMPTY Immediately
i | Ignore Line Change Events (EV_CTS,DSR,RLSD)
i | Block Line Changes (SetRts(), etc.)
s | This port is being shared

/pnot=1,2-3,*:rmax,rtime,rwinmax,tmax,ttime
Port Data Notification Settings

Optional Device Configuration Parameters
/product="abc" | Product name displayed in Device Manager (default: "Standard RealPort device")
/name="abc" | User-Specified device name
/desc="abc" | User-Specified device description
/altfriendly | Display alternative Friendly Name
/tcpport=n | RealPort service TCP port (default: 771)
/tcpcontout=n | Open socket connection timeout (default: 0)
/tcpfastpoll=n | Frequency of attempts (default: 3000 msec.)
/tcpfastlimit=n | Attempts before backing off (default: 3)
/tcpslowpoll=n | Frequency once backed off (default: 10000)
/tcpslowlimit=n | Attempts before giving up (default: 0/inf.)
/tcpblackoutopen | Fail COM Open if tcpfastpoll not elapsed
/netwaitcomopen | Wait for COM Open request before connecting
/udpresolveip=n | UDP IP Resolution Scheme: 0: Once, 1: After no RX timeout, 2: Always
/udpnorxtimeout=n | UDP IP Resolution Timeout: No. seconds without RX before re-resolving IP
/passcode="abc" | Value sent to device to authenticate user
/encrypt | Use Encrypted RealPort
/encxport=n | Encrypted RealPort service port (default: 1024)
/keepalivefreq=n | Send keep alive after n ms. of inactivity
/keepalivealways | Send keep alives even if no ports are open
/nonagling | Disable TCP Nagle Algorithm
/silentevents | Do not log device activity to Event Viewer
/execonnect="cmd" | Execute "cmd" when netw. session is started
/execunless | Execute "cmd" only if device I.P. changed
/execfreq=n | Execute "cmd" this often while connected (ms.)
/hwtype=n | Device hardware type
/hwrevision=n | Device hardware revision
/fwversion="abc" | Device firmware version string
/okencryption | Device supports encryption
/okauthentication | Device supports authentication
/oktcplisten | Device supports TCP-listen
/netprofile="..." | "typical", "modified", "less-over", "low-over", or "udp"
/vendorid=0x... | ADDP Vendor ID (default: 0x44494749 (Digi))
/version=n | RealPort driver build number

Optional Setup Parameters
/silent | Suppress console output
/checkcoms | Stop if new COM names are already claimed
/skipquery | Don't query device for additional parameters
/skipqueryalways | Never verify remote device from Wizards
/skipenumerations | On /install: always, on /update: one-time
/installmodeminf | Install Modem INF file (causes Security prompt)


RealPort Driver Network Profiles

Device and Port Network Profiles

The following table illustrates how various driver settings are set when configuring device and port network profiles.

Note that setting a network profile may apply to the device and each of the ports, or it may just apply to a single port.

E.g., on device installation, the choice of a Default Network Profile applies to the device and all the ports. The same is true when one chooses a new network profile using the Factory Defaults... dialog. However, to reset just the profile of a single port -- without affecting any device settings -- use the Port Network Profile dialog.

Feature |  |  | Network Profile
Name | Command-line | Units | Typical Settings | Modifed Read/ Write | Less Over- head | Low Over- head/ No Deltas
Device Features |  |  |  |  |  |
Device Network Connection Settings |  |  |
Connect Timeout | /tcpcontout | Secs. | 0 | 0 | 30 | 30
Retry Frequency | /tcpfastpoll | Msec. | 3,000 | 3,000 | 30,000 | 30,000
Retry Count | /tcpfastlimit | Count | 3 | 3 | 3 | 3
Offline Frequency | /tcpslowpoll | Msec. | 10,000 | 10,000 | 90,000 | 90,000
Fail COM Open if tcpfastpoll (Retry Frequency) not elapsed | /tcpblackoutopen | Yes/No | No | No | No | Yes
Wait for COM Open req. before connecting | /netwaitcomopen | Yes/No | No | No | No | No
Device Watchdog Settings |  |  |
Send Keep Alive Packets Inactivity Timeout | /keepalivefreq | Msec. | 10,000 | 10,000 | 285,000 | 0 (Off)
Send even if no ports open | /keepalivealways | Yes/No | YES | YES | YES | No
Port Features |  |  |  |  |  |
Port Advanced Settings | /padv=1,2-3,*:[{+|-}{e|s|o|b},...] |  |
Skip Enumerations | /padv=...:+e | Yes/No | No | No | YES | YES
Always Grant Port Opens | /padv=...:+o | Yes/No | No | No | YES | YES
Never Cause Serial Call to Block | /padv=...:+b | Yes/No | No | No | YES | YES
Port TCP Settings | /ptcp=1,2-3,*: [{+|-}{c|t|i|s},...],drainonclose |  |
Complete Writes Immed. | /ptcp=…:+c | Yes/No | No | YES | YES | YES
Immed. SERIAL_EV_TXEMPTY | /ptcp=…:+t | Yes/No | No | YES | YES | YES
Ignore Line Change Events | /ptcp=…:+i | Yes/No | No | No | No | YES
Verify all data sent on close | /ptcp=…,drainonclose | Msec. | 2,000 | 2,000 | 0 | 0
Port TCP Notification Settings | /pnot=1,2-3,*: rmax,rtime,rwinmax,tmax,ttime |  |
Hold data until this many bytes are received | /pnot=…:rmax,… | Count | 1 | 256 | 256 | 256
Or until this many msec pass since last byte | /pnot=…,rtime,… | Msec. | 10 | 277 | 277 | 277
Notify driver after sending this many bytes | /pnot=…,tmax,… | Count | 1 | 3,072 | 3,072 | 3,072
Or this many msec pass since last update | /pnot=…,ttime | Msec. | 10 | 554 | 554 | 554
Notify device after receiving this many bytes | /pnot=…,rwinmax,… | Count | 0 | 3,072 | 3,072 | 3,072


Updating/Removing Digi RealPort Devices and Software

Update Digi RealPort Devices and Software

The latest version of Digi RealPort for Windows is available via Microsoft Windows Update and from the Digi Web site, http://www.digi.com/.

Windows Update can automatically download and/or install software updates as they become available. Go to System Properties and click on the tab marked "Automatic Updates" to view or change your PC's Windows Update settings.

You can also download the latest software package from Digi and update manually using the Digi RealPort Setup Wizard.


Updating Digi RealPort Software

You need administrative privileges to update devices.

Please be sure you are logged on as Administrator or as a member of the Administrators group.

Run the RealPort Setup Wizard, Setup.exe, and select the option, "Update Digi RealPort Software". Click "Next >".

The Wizard now updates each installed Digi RealPort device to the latest device drivers and software.

When complete, click "Finished" to dismiss the Wizard.

Skip Device Enumerations on Update

Select to temporarily disable Serenum. This prevents Serenum from opening each of the ports after a device has been updated. Each port's original setting is restored after the update.


Upgrading from FAS to Digi RealPort for Windows

If you have previously installed the EtherLite driver for an EtherLite device (EtherLite 2/8/16/32/80/160/162), follow these steps to upgrade to the current RealPort driver:

  1. Uninstall the old EtherLite device driver and reboot the system.

  2. Update the EtherLite firmware using the DGIPSERV utility, which can be downloaded along with the latest firmware from the Digi Support Web site, http://www.digi.com/support/.

  3. Run the RealPort Setup Wizard to install the RealPort device driver.

  4. Note that EtherLite devices will not be detected by the RealPort Setup Wizard during device discovery. To install an EtherLite device, you will have to choose <Device not listed> and manually enter its I.P. address. See the RealPort Setup Wizard for more details.


Updating Device Firmware

Please visit the Digi Support Web site for downloads of the latest device firmwares, as well as instructions on updating your devices to the latest firmware.


Updating/Removing Digi RealPort Devices and Software

Remove Digi RealPort Devices and Software

You can remove one or more devices or remove all devices and RealPort software using the Digi RealPort Setup Wizard.


Removing Digi RealPort Devices from Windows

You need administrative privileges to remove devices from Windows.

Please be sure you are logged on as Administrator or as a member of the Administrators group.

Run the Digi RealPort Setup Wizard, Setup.exe, and select the option, "Remove an Existing Device". and follow the Wizard prompts.

Run the RealPort Setup Wizard, Setup.exe, and select the option, "Remove an Existing Device". Click "Next >".

Select the device or devices you want to remove. Use the Ctrl key to select multiple devices. Click "Next >" when finished.

The devices you selected are now removed from Windows. If you opted to remove all devices, the Digi RealPort device driver and any associated services will also be stopped.

When complete, click "Finished" to dismiss the Wizard.


Removing Digi RealPort for Windows Software

You need administrative privileges to remove devices and device driver software from Windows.

Please be sure you are logged on as Administrator or as a member of the Administrators group.

Run the RealPort Setup Wizard, Setup.exe, and select the option, "Remove an Existing Device". Click "Next >".

Click the button, "Select All", and then click Click "Next >".

All Digi RealPort devices are now removed from Windows. In addition, the Digi RealPort device driver and any associated services are stopped.

When complete, click "Finished" to dismiss the Wizard.


Network Serial Programming Notes

Topics

Q: How is communicating with a RealPort COM port different than with a native COM port, like COM1?

Q: How come writing serial data is so much slower than the actual baud rate?

Q: How come ReadFile on COM1 returns complete messages, but with RealPort, ReadFile returns partial messages?

Q: If my application is in the middle of a write (e.g., has called WriteFile) and the remote Digi device goes offline or the network connection is lost, my application hangs. What is happening?

Q: My application hangs when it calls WaitCommEvent, even when receiving serial data or while line events are being generated. This doesn't happen with the native COM ports.

Q: To communicate with a serial device attached to the remote Digi device, I need to use RTS Toggle. Is there a good way to do this? Also, is there a way to set the pre- and post-delays with my application?

Q: Can I automatically enable and disable RealPort devices and software?

Q: Does RealPort work on Windows Embedded operating systems?

Q: How is communicating with a RealPort COM port different than with a native COM port, like COM1?

RealPort COM ports support the same set of standard IOCTLs that the native COM ports support (and thus RealPort COM ports supports all standard Win32 communication calls defined in the Windows SDK, such as SetCommState, GetCommStatus, etc.).

However, when an application writes serial data to a built-in serial port (i.e., native serial port, such as COM1), the write data is handled somewhat differently than it is by the RealPort driver.

Generally, data written to a native serial port (i.e., using WriteFile) is transmitted very quickly (unless, of course, flow control is asserted, such that the port isn't allowed to transmit any data). The reason that data is transmitted quickly is because the driver communicates with the serial port UART directly (i.e., via the PCI bus), and the UART is always guaranteed to be "reachable" by the native serial port driver. E.g., assuming flow control is disabled, when an application calls WriteFile, the driver manipulates the UART until all the bytes are sent and then completes the WriteFile request.

When using a RealPort COM port, on the other hand, the RealPort driver doesn't communicate directly with the serial UART. Rather, the driver communicates across a network with software running on a remote device (called firmware), and the remote firmware interfaces with the serial UART.

Consequently, when writing serial data to a RealPort COM port, the serial data is first transmitted across the network, and then the driver waits for the firmware to indicate that the serial data has been delivered to the UART and transmitted. As such, when designing a serial application that uses RealPort, you must consider the latency added by the network and the firmware. You must also consider that networks are unreliable, and that messages may be delayed (or even lost, if a network connection is lost).

These considerations are especially important for applications that set their own timeouts when doing serial communication. I.e., if your application sets a timer and calls WriteFile, and then times-out if WriteFile doesn't complete within a set time, you may find that the application needs a more generous timeout when using a RealPort COM port.

These considerations also apply to reading data (ReadFile) and to changing line signals (using EscapeCommFunction or SetCommState, for example). I.e., if your application requests hardware flow control, the RealPort driver first sends a request to the remote device (firmware) asking that it enable hardware flow control, and then the RealPort driver must wait for the firmware to send a message back saying that it has enabled hardware flow control. According to the Win32 API, the RealPort driver must wait for this confirmation message before indicating to the user application that the request has been fulfilled. Consequently, while waiting for this confirmation message, the call to EscapeCommFunction or SetCommState (or whatever) blocks, and that thread in the user application blocks.

If you would rather that the driver not wait for confirmation from the firmware that write data has been delivered to the serial UART, enable the feature "Complete Write Requests Immed.". See the Port TCP tab for more details.

If you would rather that the driver not block other serial calls, like EscapeCommFunction or SetCommState, enable the feature "Guarantee Non-blocking Serial Calls (excl. WriteFile)". See the Port Advanced tab for more details.

Lastly, if you would rather that the driver not block an application's attempt to open a port (using CreateFile, for instance), enable the feature "Always Grant Port Open Requests". See the Port Advanced tab for more details.

Q: How come writing serial data is so much slower than the actual baud rate?

If your application seems to write data to the RealPort COM port very slowly when compared to a native serial port (i.e., COM1), consider enabling and testing usage of the "Complete Write Requests Immediately" option (found on the Port TCP tab).

Such behavior is typical of applications that makes many small writes (e.g., applications that call WriteFile frequently to write small amounts of data (i.e., <100 bytes)), and make many writes before attempting to read any data.

For instance, an application that calls WriteFile one hundred times with a sixteen byte buffer to write sixteen hundred bytes will perform much slower than an application that calls WriteFile once with a sixteen hundred byte buffer.

The reason for this is that the RealPort driver has to communicate with the remote Digi device before it can complete each WriteFile call. Specifically, the RealPort driver has to get confirmation from the remote Digi device that the write data has been delivered to the serial UART and transmitted on the serial wire.

If "Complete Write Requests Immediately" is enabled, the RealPort driver doesn't wait for this confirmation from the remote Digi device; instead, the RealPort driver returns control to the user application immediately. This would cause an application that calls WriteFile one hundred times to write sixteen hundred bytes perform just like an application that calls WriteFile once to write those bytes.

Q: How come ReadFile on COM1 return complete messages, but with RealPort, ReadFile returns partial messages?

Some legacy serial applications are mistakenly written based on the presumption that each call to ReadFile will return a complete message.

E.g., consider a serial device that is poll-driven, such that a host application sends requests to the device and the device sends back a response. Suppose the response is small, on the order of eight bytes.

In it's simplest form (albeit incorrect), the code driving such an application might call WriteFile to issue the request and then call ReadFile once to consume the bytes. If read timeouts are enabled (so that ReadFile does not block forever if the device is off-line or otherwise not responding), knowing that WriteFile blocks until the write request is physically transmitted, and assuming that the baud rate is set fairly fast, one might find during testing (of a native port, like COM1) that one call to ReadFile will always return the complete message of eight bytes.

Unfortunately, that ReadFile always returns with eight bytes is not a guarantee, it's just a fortuitous event. Many times, it's because the serial device responds between the time WriteFile completes and when ReadFile is called, and so the serial driver has already received the complete message by the time ReadFile is called.

Furthermore, note that a native port is directly attached to a computer and to the serial line, and can process serial data much faster -- and much more consistently -- than a network-enabled serial port. A network-enabled port introduces latency into all serial transactions because of the network.

Another problem with network-enabled ports is that serial data might span more than one network packet. One solution might be to configure the network-enabled device to coalesce data into fewer packets -- i.e., so that the eight byte serial response is always sent in one network packet, hoping that ReadFile will return all eight bytes to the application at once. Unfortunately, TCP/IP networks do not guarantee that packets will not be split into multiple packets while being transmitted.

One solution some application use to try to get all the read data they want in one call to ReadFile is to use inter-character read timeouts. Unfortunately, inter-character timeouts are not reliable on network-enabled ports, because the timeout is calculated on the host machine and not at the UART. In other words, if the eight-byte message gets split into two packets, the inter-character delay is calculated between reception of the first and second network packet, which really doesn't indicate how much time actually passes between reception of each byte at the UART.

The correct use of ReadFile is to call it multiple times until all bytes of a message are consumed or until the application enters an exception state, such as timing-out if a complete message isn't received within a certain amount of time.

Q: If my application is in the middle of a write (e.g., has called WriteFile) and the remote Digi device goes offline or the network connection is lost, my application hangs. What is happening?

By default, Windows does not timeouts for reads (ReadFile) or writes (WriteFile). If your application has not modified this (called SetCommTimeouts, for instance) then the RealPort driver will continue trying to write data until the request can be processed -- meaning, if your device is offline or if the network is failing, then the RealPort driver may never complete the request (and your application's call to ReadFile or WriteFile will never return). This is analogous to enabling hardware flow control, initiating a lengthy write request, and then physical pulling the serial cable in the middle of a write (only this can happen to the RealPort driver even without flow control enabled, if "Complete Write Requests Immed." is disabled and you remove the Ethernet cable, for instance).

Also consider that writes and reads may take longer depending on network congestion and the number of network hops needed to make it to the remote Digi device. If this is the case, your application may appear to hang for brief periods but will become responsive again. To prevent against this, write your serial application so that the Win32 serial communication calls are not in the same thread as the GUI code.

Q: My application hangs when it calls WaitCommEvent, even when receiving serial data or while line events are being generated. This doesn't happen with the native COM ports.

First verify that the serial port on the remote Digi device is connected to something that is going to respond to serial data. Next, verify that the serial cable connecting the remote Digi device to your serial device is correctly pinned-out, otherwise you may not have access to all the signals on your serial device (such as DTR, RTS, etc., or even the read or write channels).

If your application calls WaitCommEvent and idles on that event before attempting to retrieve incoming read data (e.g., with ReadFile), verify that your applications calls SetCommMask and sets EV_RXCHAR before it is possible that any serial data has been received -- i.e., if you expect your serial device to respond to a message that's about to be sent, set EV_RXCHAR first, then call WriteFile, and finally call WaitCommEvent to wait for the response. If your applications calls WriteFile first and the response is received before your application sets EV_RXCHAR, the final call to WaitCommEvent may block forever (it may also be cancelled by your application or completed by the RealPort driver if your serial device sends more data).

You may also find it useful to call ClearCommError to check for the presence of received serial data that your application can fetch by calling ReadFile. However, do not assume that calling ClearCommError and then setting and waiting for EV_RXCHAR will work -- data may be received after your application calls ClearCommError but before it sets EV_RXCHAR.

Use ClearCommError if your application polls for received serial data. Use WaitCommEvent if your application would rather be signalled when serial data arrives, but be sure your application calls SetCommMask and sets EV_RXCHAR before writing any data that may generate a response from your serial device.

If you application cannot guarantee that it set EV_RXCHAR first and you still want to implement a response-driven architecture (rather than polling), set EV_RXCHAR, then call ClearCommError (and read any bytes that might be indicated), and then call WaitCommEvent. Note that the wait might be satisfied immediately and EV_RXCHAR returned for the bytes your application just read! If this happens, call ClearCommError and check that COMSTAT.cbInQue is nonzero; read the bytes if it is, otherwise call WaitCommEvent and continue waiting (EV_RXCHAR will be signalled again when more bytes arrive).

Q: To communicate with a serial device attached to the remote Digi device, I need to use RTS Toggle. Is there a good way to do this? Also, is there a way to set the pre- and post-delays with my application?

To enable RTS Toggle, simply call SetCommState and specify DCB.fRtsControl = RTS_CONTROL_TOGGLE. (Note that you may also have to set fOutxCtsFlow to TRUE, depending on your serial device).

The pre- and post-delay may not be adjusted by the RealPort driver or via the Win32 serial communications API. Instead, you must adjust these settings on the remote Digi device itself. Please consult the documentation for your Digi device for more details.

Q: Can I automatically enable and disable RealPort devices and software?

There are a number of ways to restart the Digi RealPort driver and Digi RealPort devices (one instance of the driver runs in kernel memory and controls all installed Digi RealPort devices).

Options for restarting the driver:

1. Reboot the PC;
2. Manually disable all RealPort devices (under Multi-port serial adapters) in the Device Manager, then re-enable them; or
3. Call devcon.exe from a command window (download the Windows DDK from Microsoft to get devcon.exe).

Using Devcon.exe to Programmatically Enable and Disable All or Some Devices

To disable the driver (and consequently disable every device) using devcon.exe, open a Command Window. Enter the command, 'devcon disable digirealportid'. E.g.,

C:\>devcon disable digirealportid
ROOT\MULTIPORTSERIAL\0000                                   : Disabled
ROOT\MULTIPORTSERIAL\0001                                   : Disabled
2 device(s) disabled.

Devcon displays the Instance Id of each device it disables. To enable just one device, use its Instance Id pre-pended by an '@' symbol. E.g.,

C:\>devcon enable @ROOT\MULTIPORTSERIAL\0001
ROOT\MULTIPORTSERIAL\0001                                   : Enabled
1 device(s) enabled.

You can use the same method to disable individual devices.

To restart every device, specify 'digirealportid' instead of the Instance Id. E.g.,

C:\>devcon enable digirealportid
ROOT\MULTIPORTSERIAL\0000                                   : Enabled
ROOT\MULTIPORTSERIAL\0001                                   : Enabled
2 device(s) enabled.

Q: Does RealPort work on Windows Embedded operating systems?

This software does not run on Windows CE or Windows Mobile.

However, some customers have reported that this software does run on Windows Embedded and Windows Embedded XP. Please note, though, that Digi International Inc. does not support running this software on Windows Embedded, Windows Embedded XP, nor any other Operating System not explicitly claimed as being supported.

The following information is supplied as-is. Digi International Inc. assumes no responsibility for the use of this information.

The Windows 2000/XP/Server 2003/x64 RealPort driver is known to run on Windows Embedded XP given the following requirements:

The RealPort driver must be installed after the operating system image has been deployed. The driver does not support being pre-installed during OS image generation (i.e., via the Target/Component Designer).

The RealPort driver requires a working networking stack (i.e., NIC driver and TCP/IP protocol) as well as the Serenum driver. Serenum will be installed automatically if the system has built-in COM ports, but it can also be added separately in Target Designer.

The image may also need to contain the Device Manager, Add New Hardware Wizard, Control Panel and Explorer components.


Troubleshooting RealPort Setup

Please visit the Digi Web site for installation documentation, as well as product and software support and downloads of the latest Windows drivers and device firmwares.

Topics

RealPort Setup Wizard Does Not Detect Device

Cannot Open COM ports above COM9

Cannot Use COM Port to Print

First COM Port Open Always Fails

Serial Mouse or Modem Detected But Nothing is Attached

Setup Returns the Error, "Only one device can be installed at a time"

COM Ports Unavailable After Uninstalling

RealPort Setup Wizard Does Not Detect Device

If the RealPort Setup Wizard does not discover your remote Digi device, do the following:

1. Verify that the device supports discovery, also known as ADDP (see its documentation; note that older Digi PortServer TS and Digi EtherLite devices do not support discovery);

2. Verify that the device is powered on and connected to the network;

3. Verify that the PC running the Setup Wizard has an Ethernet interface with a valid I.P. address;

4. Verify that there are no routers between the remote Digi device and the PC running the Setup Wizard (routers will not relay the discovery broadcast message);

5. Verify that firewalls and anti-virus software have been disabled on the PC;

6. Verify that firewalls on the network are not blocking the discovery messages (you may need to disable any firewalls between the remote Digi device and the PC); and

7. Verify that you can ping or access the Web interface of the remote Digi device from the PC.

Please note that older PortServer TSs running 82000716 firmware and Digi EtherLite devices will not be discoverable through the RealPort driver installation process. You will need to select <Device Not Listed> to install these devices.

Opening COM ports above COM9

When using functions like CreateFile to open a COM port, keep in mind that you must prepend "\\.\" to the front of the COM port name as specified by the Win32 API (e.g., "\\.\COM10"). When your application opens a port with a name such as "COM1" (without the backward slashes), it is using the old 16 bit API (which Microsoft still supports, but which also only supports ports up to "COM9"). Opening a port with a string like "\\.\COM9" is the correct Win32 format.

Cannot Use COM Port to Print

If you plan to use the RealPort driver with serial printers, you have to reboot Windows or restart the print spooler after installing a device or renaming ports to see the new ports listed in the Print Spooler's list of available ports for printing. This is a known limitation of the Print Spooler, which does not detect changes in the list of available ports automatically. To restart the spooler service, open a Command Window (as Administrator) and type "net stop spooler" <ENTER> followed by "net start spooler" <ENTER>.

If you experience problems printing to a serial printer from a port, go to the device's Device Properties dialog in Device Manager and enable "Complete Write Requests Immed." for that port (see the Port TCP tab).

First COM Port Open Always Fails

If your first attempts to open a RealPort COM port fail after you have rebooted your remote Digi device, this is normal. The RealPort driver maintains a TCP socket connection to the remote Digi device at all times, and if this socket is idle and the connection goes bad (i.e., because the device reboots or the network is reset), the first attempt to open the COM port will fail.

To help avoid this, enable RealPort Keep-Alive packets, found on the Device Watchdog tab. Sending Keep-Alive packets will cause the RealPort driver to detect bad sockets more quickly.

Serial Mouse or Modem Detected But Nothing is Attached

If your local PC adds serial mouses or modems whenever it boots (which can also make it so the RealPort COM ports cannot be opened), check the "Do Not Scan Modems on Boot (Serenum SkipEnumerations)" option on the Device Advanced tab to disable Windows from auto-detecting the serial mouses and modems. You will have to manually remove the rogue serial mouses and modems using the Device Manager.

Setup Returns the Error, "Only one device can be installed at a time"

The Digi RealPort Setup Wizard (Setup.exe, Setup32.exe, or Setup64.exe) sometimes returns the following error, even when the user is not installing any devices:

An error was encountered while preparing setup: Only one device can be installed at a time.
Please wait until the other device installation finishes.

Windows periodically scans for new Plug-and-Play devices in the background, and other drivers may sometimes access the Windows Device Installation interface, in which case it is best to wait for the other processes to complete their operation. Please wait until the Plug-and-Play manager handles all pending device installation activities and then try to run the RealPort Setup Wizard again. Unless the user is specifically installing another device, you can usually try again immediately to run the RealPort Setup Wizard.

COM Ports Unavailable After Uninstalling

To remove all parts of the RealPort driver from the Registry, first open a Command window and run the following RealPort Setup Wizard CLI command:

setup /removeall.

Next, open your favorite Registry editor (e.g., Start > Run > "regedit").

Now, manually edit the following locations. The usual disclaimer applies- Edit the Registry at your own risk!

HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\COM Name Arbiter\ComDB

Modify the COM port bitmap, ComDB, managed by the COM arbiter.

The bitmap is organized into 8-bit Big Endian chunks. E.g., if just COM1 is installed, ComDB is "01 00 00"...; if COMs 1 & 2 are installed, ComDB is "03 00 00"...; if COM 5 is installed, ComDB is "10 00 00"...; and finally, if just COM 9 is installed, ComDB is "00 01 00"....

HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Class\{50906CB8-BA12-11D1-BF5D-0000F805F530}

Go to the Multi-port serial class software key and delete any RealPort instances under it (delete the keys named '0000', '0001', etc., which have 'MatchingDeviceId' keys equal to 'digirealportid').

HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Class\{4D36E978-E325-11CE-BFC1-08002BE10318}

Go to the Ports class software key and delete any RealPort ports (delete the keys named '0000', '0001', etc., that have keys named 'MatchingDeviceId' with the value 'dgrpport').

HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Enum\DGRPPORT

First Right-click DGRPPORT and choose Permissions.... Set 'Full Control' to 'Allow'. Next, delete the port hardware keys (delete either the whole DGRPPORT branch or delete the individual branches under it).

HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Enum\Root\MULTIPORTSERIAL

Check the Root hardware key for any Digi devices (delete the keys named '0000', '0001', etc., that have the key 'HardwareID' equal to 'DigiRealPortId').

HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\DIGIRPS\Enum

Check the service key. Delete any keys besides 'Count' and 'NextInstance'. Set both 'Count' and 'NextInstance' to '0'.

HKEY_LOCAL_MACHINE\HARDWARE\DEVICEMAP\SERIALCOMM

Delete any RealPort COM ports referenced by keys in the Serialcomm branch.


RealPort Copyright Notices

Digi Notice

Digi RealPort Software is protected by U.S. Patent No. 6,047,319. Other Patents Pending.

Third-Party Notices

OpenSSL License

This product includes software developed by the OpenSSL Project for use in the OpenSSL Toolkit (http://www.openssl.org/), Copyright © 1998-2006 The OpenSSL Project. All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

3. All advertising materials mentioning features or use of this software must display the following acknowledgment: "This product includes software developed by the OpenSSL Project for use in the OpenSSL Toolkit. (http://www.openssl.org/)"

4. The names "OpenSSL Toolkit" and "OpenSSL Project" must not be used to endorse or promote products derived from this software without prior written permission. For written permission, please contact openssl-core@openssl.org.

5. Products derived from this software may not be called "OpenSSL" nor may "OpenSSL" appear in their names without prior written permission of the OpenSSL Project.

6. Redistributions of any form whatsoever must retain the following acknowledgment: "This product includes software developed by the OpenSSL Project for use in the OpenSSL Toolkit (http://www.openssl.org/)"

THIS SOFTWARE IS PROVIDED BY THE OpenSSL PROJECT ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE OpenSSL PROJECT OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

This product includes cryptographic software written by Eric Young (eay@cryptsoft.com). This product includes software written by Tim Hudson (tjh@cryptsoft.com).

Original SSLeay License

This product includes cryptographic software written Copyright © 1995-1998 Eric Young (eay@cryptsoft.com). All rights reserved.

This package is an SSL implementation written by Eric Young (eay@cryptsoft.com). The implementation was written so as to conform with Netscapes SSL.

This library is free for commercial and non-commercial use as long as the following conditions are aheared to. The following conditions apply to all code found in this distribution, be it the RC4, RSA, lhash, DES, etc., code; not just the SSL code. The SSL documentation included with this distribution is covered by the same copyright terms except that the holder is Tim Hudson (tjh@cryptsoft.com).

Copyright remains Eric Young's, and as such any Copyright notices in the code are not to be removed. If this package is used in a product, Eric Young should be given attribution as the author of the parts of the library used. This can be in the form of a textual message at program startup or in documentation (online or textual) provided with the package.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the copyright notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

3. All advertising materials mentioning features or use of this software must display the following acknowledgement: "This product includes cryptographic software written by Eric Young (eay@cryptsoft.com)" The word 'cryptographic' can be left out if the rouines from the library being used are not cryptographic related :-).

4. If you include any Windows specific code (or a derivative thereof) from the apps directory (application code) you must include an acknowledgement: "This product includes software written by Tim Hudson (tjh@cryptsoft.com)"

THIS SOFTWARE IS PROVIDED BY ERIC YOUNG ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

The licence and distribution terms for any publically available version or derivative of this code cannot be changed. i.e. this code cannot simply be copied and put under another distribution licence [including the GNU Public Licence.]


.topic 1
Processes specified changes and dismisses dialog.

.topic 2
Cancels any changes and dismisses dialog.

.topic 2601

.topic 2602

.topic 2603
Displays the multi-port icon.

.topic 2604
Displays a port icon.

.topic 2605
Displays a computer icon.

.topic 2606
Displays a search icon.

.topic 2607

.topic 2608

.topic 2609

.topic 2610

.topic 2611

.topic 2612

.topic 2613

.topic 2614

.topic 2615

.topic 11001
Displays the name of the software.

.topic 11002
Displays the company name.

.topic 11003
Displays the application copyright.

.topic 11004
Displays the company URL.

.topic 11005
Displays the support URL.

.topic 26501
The terms of the license agreement.

.topic 26502
Accepts the terms of the license agreement and proceeds to the next step.

.topic 26503
Rejects the terms of the license agreement and exits the application.

.topic 26504
Welcome to the Digi RealPort Setup Wizard.

.topic 26505
Welcome to the Digi RealPort Setup Wizard.

.topic 26506
Select to install a new Digi RealPort device on this system.

.topic 26507
Select to remove one or more existing Digi RealPort devices from this system.

.topic 26508
Select to update all of the devices to the latest version of Digi RealPort for Windows.

.topic 26509
Select to temporarily disable Serenum. This prevents Serenum from opening each of the ports after a device has been updated. Each port's original setting is restored after the update.

.topic 26510
To continue, click Next.

.topic 26511
Displays a list of Digi RealPort devices found on your network.

.topic 26512
Removes all RealPort devices and all RealPort software from your local machine.

.topic 26513
Selects all the devices in the list.

.topic 26514
Deselects all the devices in the list.

.topic 26515
Indicates progress of device installation.

.topic 26516
Displays the progress of device installation.

.topic 26517
Displays completion text after the device has been installed.

.topic 26518
Displays completion text after the device has been installed.

.topic 26519
Displays the name of the application.

.topic 26520
Displays the version of the application.

.topic 26521
Displays the copyright for the application.

.topic 26522
Click to access the Digi Web site with a new browser window.

.topic 27501
Click to access the Digi Web site with a new browser window.

.topic 27502
Indicates that the Digi RealPort Network Service is not running. You may be unable to connect to your device unless the service is running.

.topic 27503
Indicates that the Digi RealPort Network Service is not running. You may be unable to connect to your device unless the service is running.

.topic 27504
Displays the name of the software.

.topic 27505
Displays this machine's operating system.

.topic 27506
Displays a list of Digi RealPort devices found on your network.

.topic 27507
Displays a warning that no Digi RealPort devices were found on your network.

.topic 27508
Check to indicate that this device will be used on a cellular network.

.topic 27509
Click this to open the Help file for help on why the Wizard cannot locate the remote device.

.topic 27510
Click to refresh the list of Digi RealPort devices found on your network.

.topic 27511
Enter the model name of the Digi RealPort device.

.topic 27512
Uses an I.P. address to locate your device on the network.

.topic 27513
Uses a MAC address to resolve the I.P. address of your device on the network.

.topic 27514
Uses a hostname to resolve the I.P. address of your device on the network.

.topic 27515
Listens on a local TCP port to which your device will connect.

.topic 27516
Choose the network profile used to configure device and port settings.

.topic 27517
Enter the I.P. address of your Digi RealPort device.

.topic 27518
Enter the MAC address of your Digi RealPort device.

.topic 27519
Enter the hostname of your Digi RealPort device.

.topic 27520
Enter the TCP port number on which the driver should listen for incoming device connections.

.topic 27521
Enter the TCP port number on which the driver should listen for incoming device connections.

.topic 27522
Enter the TCP port number on which the driver should listen for incoming device connections.

.topic 27523
Enter the TCP port number on which the driver should listen for incoming device connections.

.topic 27524
Enter the TCP port number of the RealPort service running on your Digi RealPort device.

.topic 27525
Enter the TCP port number of the RealPort service running on your Digi RealPort device.

.topic 27526
Enter the TCP port number of the RealPort service running on your Digi RealPort device.

.topic 27527
Enter the UDP base port of the UDP socket ports. The first UDP serial port is the same as the base port, the second UDP port is the base port plus one, etc.

.topic 27528
Enter the UDP base port of the UDP socket ports. The first UDP serial port is the same as the base port, the second UDP port is the base port plus one, etc.

.topic 27529
Enter the number of physical serial ports on the Digi RealPort device.

.topic 27530
Enter the number of physical serial ports on the Digi RealPort device.

.topic 27531
Select the COM name of your first port from the drop-down list.

.topic 27532
Prevents Windows from scanning for modems and other serial devices on your ports (Serenum SkipEnumerations).

.topic 27533
Check this if the Digi RealPort device supports Encrypted RealPort.

.topic 27534
Check this if the Digi RealPort device supports RealPort Authentication.

.topic 27535
Check this if the Digi RealPort device supports RealPort compression.

.topic 27536
Check this if the Digi RealPort device supports TCP-Listen connections.

.topic 27537
Click to configure installation options for the Digi RealPort Setup Wizard.

.topic 27538
Click to display detailed help about the properties on this page.

.topic 27539
Check to have RealPort software registered with the Add or Remove Programs Wizard in Control Panels.

.topic 27540
Check to have RealPort software installed to C:\Program Files (or some other location) and have links created in your Start Menu.

.topic 27541
Check to have RealPort software installed to C:\Program Files (or some other location) and have links created in your Start Menu.

.topic 27542
Check to browse to a location to install Digi RealPort software.

.topic 27543
Check to add the RealPort software directory to your PATH environment variable. You can then access the RealPort Setup Wizard from any Command Window or from the Run menu using the application name, "rpsetup".

.topic 27544
Check to install the Modem INF file for Digi device modems. Note that this will cause Windows to issue a security prompt during installation.

.topic 27545
Select the COM name of your first port from the drop-down list.

.topic 27546
Displays the COM names of the ports being installed.

.topic 27547
Click to configure your ports now.

.topic 27548
Click to configure your ports now.

.topic 27549
Displays the model name of the previous Digi RealPort device.

.topic 27550
Displays the new model name of the Digi RealPort device.

.topic 27551
Displays the number of ports on the previous Digi RealPort device.

.topic 27552
Displays the new number of ports on the Digi RealPort device.

.topic 27553
Displays the port network profiles set for the previous Digi RealPort device.

.topic 27554
Displays the new port network profiles being set for the Digi RealPort device.

.topic 27555
Displays the MAC address of the previous Digi RealPort device.

.topic 27556
Displays the new MAC address of the Digi RealPort device.

.topic 27557
Displays the network address of the previous Digi RealPort device.

.topic 27558
Displays the new network address of the Digi RealPort device.

.topic 27559
Displays the hostname of the previous Digi RealPort device.

.topic 27560
Displays the new hostname of the Digi RealPort device.

.topic 27561
Displays the TCP port of the RealPort service of the previous Digi RealPort device.

.topic 27562
Displays the new TCP port of the RealPort service of the Digi RealPort device.

.topic 27563
Displays model name and I.P. address or Device name

.topic 27564
Displays name of driver.

.topic 27565
Displays driver copyright.

.topic 27566
Displays driver patents.

.topic 27567
Displays the model of the Digi RealPort device.

.topic 27568
Displays the model of the Digi RealPort device.

.topic 27569
Displays the number of physical ports on your Digi RealPort device.

.topic 27570
Displays the number of physical ports on your Digi RealPort device.

.topic 27571
Displays a description of your Digi RealPort device.

.topic 27572
Displays a description of your Digi RealPort device.

.topic 27573
Displays the network address (IP, MAC, or DNS name) of the Digi RealPort device.

.topic 27574
Displays the network address (IP, MAC, or DNS name) of the Digi RealPort device.

.topic 27575
Click to open a browser window pointed at your device. (Note: Not all devices support Web configuration.)

.topic 27576
Click to open a browser window pointed at your device. (Note: Not all devices support Web configuration.)

.topic 27577
This device does not support Web configuration or the address of this device is unknown.

.topic 27578
Displays the TCP port of the RealPort service on your Digi RealPort device.

.topic 27579
Displays the TCP port of the RealPort service on your Digi RealPort device.

.topic 27580
Displays the status of the network connection between this computer and your Digi RealPort device.

.topic 27581
Displays the status of the network connection between this computer and your Digi RealPort device.

.topic 27582
Displays the security settings configured for your Digi RealPort device.

.topic 27583
Displays the security settings configured for your Digi RealPort device.

.topic 27584
Click to configure the properties of your Digi RealPort device.

.topic 27585
Displays the model name and I.P. address or Device name of your Digi RealPort device.

.topic 27586
Indicates that the specified MAC address or DNS name does not resolve into a valid I.P. address.

.topic 27587
Specifies a device's Device name. The Device name is displayed in the Device Manager category, Multi-port serial adapters.

.topic 27588
Click to access the Digi Support site with a new browser window.

.topic 27589
Specifies a device's Device name. The Device name is displayed in the Device Manager category, Multi-port serial adapters.

.topic 27590
Specifies a device's Device description. The user is free to set this to anything desired.

.topic 27591
Specifies a device's Device description. The user is free to set this to anything desired.

.topic 27592
Specifies that the name displayed in the Device Manager is the User Name rather than the device product name.

.topic 27593
Click to change the COM names of the ports on this device.

.topic 27594
Click to select settings to reset to factory defaults.

.topic 27595
Click to display detailed help about Digi RealPort driver configuration.

.topic 27596
Locates your device by its IP address.

.topic 27597
Locates your device by its MAC address.

.topic 27598
Locates your device by its DNS name.

.topic 27599
Initiates the connection by another method, such as TCP-Listen.

.topic 27600
Enter the IP address of your Digi RealPort device.

.topic 27601
Enter the MAC address of your Digi RealPort device.

.topic 27602
Enter the DNS hostname of your Digi RealPort device.

.topic 27603
Choose the method by which the driver and device will establish a network connection.

.topic 27604
Click to Browse for your Digi RealPort device on the network.

.topic 27605
Sends a query to the device with the specified MAC address to determine if it supports any additional connection methods, such as TCP-Listen. If your device is not online or not on your local network, you can still manually select with other methods your device supports.

.topic 27606
Opens a dialog so you can configure the network connection method chosen in the drop down list.

.topic 27607
Enter the TCP port number of the RealPort service running on your Digi RealPort device.

.topic 27608
Enter the TCP port number of the RealPort service running on your Digi RealPort device.

.topic 27609
Enter the TCP port number of the RealPort service running on your Digi RealPort device.

.topic 27610
Click to change the network connection settings for this device.

.topic 27611
Displays a warning if the remote device with a specific MAC address does not have the same IP address or TCP port as indicated here.

.topic 27612
Displays a warning if the remote device with a specific MAC address does not have the same IP address or TCP port as indicated here.

.topic 27613
Click this to use the MAC address of the device with the current IP address.

.topic 27614
Click this to use the IP address of the device with the old MAC address.

.topic 27615
Click to ignore the mismatch between the I.P. address used by the driver and the I.P. address of the device at the MAC address indicated.

.topic 27616
Displays a warning if the remote device with the specific IP address is using a different TCP port than configured here.

.topic 27617
Displays a warning if the remote device with the specific IP address is using a different TCP port than configured here.

.topic 27618
Click this to use the RealPort port of the device with the specified IP address.

.topic 27619
Click this to ignore the RealPort port of the device with the specified IP address and to use the TCP port configured here.

.topic 27620
Connect Timeout determines the maximum time per connection attempt to wait from a connection response from the remote device. If 0, the default Windows value is used. If the Nagle algorithm is disabled (see the Device Advanced tab), each connection attempt will only consist of one network packet, otherwise each attempt could consist of multiple (generally at most three) packets. In most cases, if Nagle is enabled and this value is 0, Windows will attempt three times to reach the remote device. The first attempt will time-out after 3 seconds, the second after 6 seconds, and the third after 12 seconds, so the complete connection attempt will take at most 21 seconds. Note that the Nagle algorithm will use longer time-outs on less responsive networks.

.topic 27621
Connect Timeout determines the maximum time per connection attempt to wait from a connection response from the remote device. If 0, the default Windows value is used. If the Nagle algorithm is disabled (see the Device Advanced tab), each connection attempt will only consist of one network packet, otherwise each attempt could consist of multiple (generally at most three) packets. In most cases, if Nagle is enabled and this value is 0, Windows will attempt three times to reach the remote device. The first attempt will time-out after 3 seconds, the second after 6 seconds, and the third after 12 seconds, so the complete connection attempt will take at most 21 seconds. Note that the Nagle algorithm will use longer time-outs on less responsive networks.

.topic 27622
Connect Timeout determines the maximum time per connection attempt to wait from a connection response from the remote device. If 0, the default Windows value is used. If the Nagle algorithm is disabled (see the Device Advanced tab), each connection attempt will only consist of one network packet, otherwise each attempt could consist of multiple (generally at most three) packets. In most cases, if Nagle is enabled and this value is 0, Windows will attempt three times to reach the remote device. The first attempt will time-out after 3 seconds, the second after 6 seconds, and the third after 12 seconds, so the complete connection attempt will take at most 21 seconds. Note that the Nagle algorithm will use longer time-outs on less responsive networks.

.topic 27623
Connect Timeout determines the maximum time per connection attempt to wait from a connection response from the remote device. If 0, the default Windows value is used. If the Nagle algorithm is disabled (see the Device Advanced tab), each connection attempt will only consist of one network packet, otherwise each attempt could consist of multiple (generally at most three) packets. In most cases, if Nagle is enabled and this value is 0, Windows will attempt three times to reach the remote device. The first attempt will time-out after 3 seconds, the second after 6 seconds, and the third after 12 seconds, so the complete connection attempt will take at most 21 seconds. Note that the Nagle algorithm will use longer time-outs on less responsive networks.

.topic 27624
Retry Frequency specifies how often to try to connect to the remote device, in milliseconds, when first trying to open the connection. Click the Help button for more details.

.topic 27625
Retry Frequency specifies how often to try to connect to the remote device, in milliseconds, when first trying to open the connection. Click the Help button for more details.

.topic 27626
Retry Frequency specifies how often to try to connect to the remote device, in milliseconds, when first trying to open the connection. Click the Help button for more details.

.topic 27627
Retry Frequency specifies how often to try to connect to the remote device, in milliseconds, when first trying to open the connection. Click the Help button for more details.

.topic 27628
Retry Count specifies the number of times to try to connect to the remote device every <i>Retry Frequency</i> milliseconds before backing off and trying evert Offline Frequency milliseconds. Click the Help button for more details.

.topic 27629
Retry Count specifies the number of times to try to connect to the remote device every <i>Retry Frequency</i> milliseconds before backing off and trying evert Offline Frequency milliseconds. Click the Help button for more details.

.topic 27630
Retry Count specifies the number of times to try to connect to the remote device every <i>Retry Frequency</i> milliseconds before backing off and trying evert Offline Frequency milliseconds. Click the Help button for more details.

.topic 27631
Offline Frequency specifies how often to try to connect to the remote device, once RealPort has already tried as many times as specified by Retry Count. Click the Help button for more details.

.topic 27632
Offline Frequency specifies how often to try to connect to the remote device, once RealPort has already tried as many times as specified by Retry Count. Click the Help button for more details.

.topic 27633
Offline Frequency specifies how often to try to connect to the remote device, once RealPort has already tried as many times as specified by Retry Count. Click the Help button for more details.

.topic 27634
Offline Frequency specifies how often to try to connect to the remote device, once RealPort has already tried as many times as specified by Retry Count. Click the Help button for more details.

.topic 27635
Offline Count specifies how many times to try to connect to the remote device, once RealPort has already tried as many times as specified by Retry Count. Click the Help button for more details.

.topic 27636
Offline Count specifies how many times to try to connect to the remote device, once RealPort has already tried as many times as specified by Retry Count. Click the Help button for more details.

.topic 27637
Offline Count specifies how many times to try to connect to the remote device, once RealPort has already tried as many times as specified by Retry Count. Click the Help button for more details.

.topic 27638
Offline Count specifies how many times to try to connect to the remote device, once RealPort has already tried as many times as specified by Retry Count. Click the Help button for more details.

.topic 27639
The reconnection throttle controls set above -- namely, Retry Frequency, Retry Count, and Offline Frequency -- normally only apply when the driver is reconnecting an interrupted connection for an already-opened port. If you would also like the driver to honor these controls whenever an application opens a COM port (i.e., via CreateFile), enable this feature. If enabled and the next reconnect is more than 5 seconds away, CreateFile returns a failure. If this feature is disabled, the driver will always try to connect to the device whenever a COM port is opened.

.topic 27640
Normally, RealPort opens the network connection to the remote device when RealPort starts. Enable this box if RealPort should only start and maintain the network connection when an application is accessing COM ports.

.topic 27641
If the device is addressed by its MAC or DNS address rather than an IP address, the MAC or DNS has to be resolved to an IP address to send packets. If "Resolve on startup" is selected, the IP address will only be resolved once, when the driver is started, and will not be resolved again until the driver is restarted. If the device gets its IP address from a DHCP server and happens to renew its lease after the driver has started, its IP address may change but the driver will still send packets to the old IP address.

.topic 27642
If the device is addressed by its MAC or DNS address rather than an IP address, the MAC or DNS has to be resolved to an IP address to send packets. If "Resolve if no RX for n secs." is selected, the IP address will be resolved first when the driver is started, and will be resolved anytime a certain amount of time passes after having last received a communication from the device. This is useful if the device gets its IP address from a DHCP server and happens to renew its lease after the driver has started, since its IP address may change.

.topic 27643
If the device is addressed by its MAC or DNS address rather than an IP address, the MAC or DNS has to be resolved to an IP address to send packets. If "Resolve for every packet sent" is selected, the IP address will be resolved for every packet sent. If using the device's DNS name, oftentimes the IP address is locally cached, so this operation will not incur much network overhead. However, if using the device's MAC address, the driver will send a broadcast message on the network before every packet sent, which will increase network overhead.

.topic 27644
Specifies how long after not receiving incoming data from the remote device at its known IP address before re-resolving the DNS or MAC address. This is useful if the device gets its IP address from a DHCP server and is likely to be assigned a new IP address when its lease expires.

.topic 27645
Specifies how long after not receiving incoming data from the remote device at its known IP address before re-resolving the DNS or MAC address. This is useful if the device gets its IP address from a DHCP server and is likely to be assigned a new IP address when its lease expires.

.topic 27646
Specifies how long after not receiving incoming data from the remote device at its known IP address before re-resolving the DNS or MAC address. This is useful if the device gets its IP address from a DHCP server and is likely to be assigned a new IP address when its lease expires.

.topic 27647
Enter the base UDP port number set on your Digi RealPort device.

.topic 27648
Enter the base UDP port number set on your Digi RealPort device.

.topic 27649
Enter the base UDP port number set on your Digi RealPort device.

.topic 27650
This setting affects how often RealPort resolves a MAC address or DNS address to an IP address for ports using UDP. Normally, RealPort resolves a MAC or DNS address to an IP address only when the COM port is first opened. If you would also like RealPort to re-resolve the IP address if a length of time elapses since the last UDP packet was received from the device, enter that value here.

.topic 27651
This setting affects how often RealPort resolves a MAC address or DNS address to an IP address for ports using UDP. Normally, RealPort resolves a MAC or DNS address to an IP address only when the COM port is first opened. If you would also like RealPort to re-resolve the IP address if a length of time elapses since the last UDP packet was received from the device, enter that value here.

.topic 27652
This setting affects how often RealPort resolves a MAC address or DNS address to an IP address for ports using UDP. Normally, RealPort resolves a MAC or DNS address to an IP address only when the COM port is first opened. If you would also like RealPort to re-resolve the IP address if a length of time elapses since the last UDP packet was received from the device, enter that value here.

.topic 27653
This setting affects how often RealPort resolves a MAC address or DNS address to an IP address for ports using UDP. Normally, RealPort resolves a MAC or DNS address to an IP address only when the COM port is first opened. If you would also like RealPort to re-resolve the IP address if a length of time elapses since the last UDP packet was received from the device, enter that value here.

.topic 27654
This setting affects how often RealPort resolves a MAC address or DNS address to an IP address for ports using UDP. Normally, RealPort resolves a MAC or DNS address to an IP address only when the COM port is first opened, or if a length of time elapses since the last UDP packet was received from the device. Check this box if RealPort should resolve the IP address of a MAC or DNS address every time it sends a UDP packet to the device.

.topic 27655
If checked, the Wizard will never query the network to alert you if your device is not connected. Use this setting if you do not need device connectivity warnings and would like to conserve network resources.

.topic 27656
Click to restore settings on this page to their default values.

.topic 27657
Click to display detailed help about the properties on this dialog.

.topic 27658
Enter the TCP port number on which the driver should listen for incoming device connections.

.topic 27659
Enter the TCP port number on which the driver should listen for incoming device connections.

.topic 27660
Enter the TCP port number on which the driver should listen for incoming device connections.

.topic 27661

.topic 27662

.topic 27663

.topic 27664

.topic 27665

.topic 27666

.topic 27667

.topic 27668

.topic 27669

.topic 27670

.topic 27671
Click to display detailed help about the properties on this page.

.topic 27672
Applies Gzip compression to serial data being transmitted across the network. Depending on the size of data packets, this increase or decrease the size of the network packet.

.topic 27673
Check to disable the TCP Nagle algorithm (network packets will be retransmitted without delay).

.topic 27674
Check to have the device log network activity to the System Event Log.

.topic 27675
Enable to quickly detect and recover from network errors or to prevent idle network connections from being closed. Note that this increases network traffic.

.topic 27676
The driver sends a keep alive packet after this many milliseconds of network inactivity.

.topic 27677
The driver sends a keep alive packet after this many milliseconds of network inactivity.

.topic 27678
The driver sends a keep alive packet after this many milliseconds of network inactivity.

.topic 27679
Configures the driver to not send keep alive packets unless one or more ports is open by an application.

.topic 27680
Configures the driver service to execute a Windows command whenever the network session to the device is active. The command may be executed once when the session is first created, or periodically while the session is active. It may be necessary to configure the service to allow it to interact with the desktop for the command to execute properly.

.topic 27681
Enter the command to be executed. The string \"%ip%\" will be substituted with the device I.P. address.

.topic 27682
Configures the driver service to not execute the command except when the first network session is established or when the device I.P. address has changed.

.topic 27683
While the network connection is active, the driver executes the indicated command once every interval of this many milliseconds.

.topic 27684
While the network connection is active, the driver executes the indicated command once every interval of this many milliseconds.

.topic 27685
While the network connection is active, the driver executes the indicated command once every interval of this many milliseconds.

.topic 27686
Allows you to edit the security settings for your device.

.topic 27687
Enter the shared secret used by the driver and device to authenticate each other; leave blank if none.

.topic 27688
Enter the shared secret used by the driver and device to authenticate each other; leave blank if none.

.topic 27689
Enables encryption of all network traffic.

.topic 27690
Enter the TCP port number of the Encrypted RealPort service running on your Digi RealPort device.

.topic 27691
Enter the TCP port number of the Encrypted RealPort service running on your Digi RealPort device.

.topic 27692
Enter the TCP port number of the Encrypted RealPort service running on your Digi RealPort device.

.topic 27693
Click to query the device about what security features it supports.

.topic 27694
Click to query the device about what security features it supports.

.topic 27695
Click to query the device about what security features it supports.

.topic 27696
Select the new COM name for the first port from the drop-down list.

.topic 27697
Displays the COM names after the ports are renamed.

.topic 27698
Check to reset the device User Name and User Description.

.topic 27699
Check to reset the device network settings found on the Device Network tab.

.topic 27700
Check to reset the advanced device network settings found on the Advanced tab.

.topic 27701
Check to reset the device security settings found on the Security tab.

.topic 27702
Check to reset the device watchdog settings found on the Watchdog tab.

.topic 27703
Check to query the device about its product type, firmware revision and feature set.

.topic 27704
Check to reset the port User Name and User Description.

.topic 27705
Check to reset the port serial settings found on the Serial tab.

.topic 27706
Check to reset the advanced settings and network settings for the port.

.topic 27707
Choose the default port profile for the ports on this device.

.topic 27708
Choose the default port profile for the ports on this device.

.topic 27709
Displays the device query progress.

.topic 27710
Displays the device query progress.

.topic 27711
Displays physical port number and COM name or Port name

.topic 27712
Specifies a port's Port name. The Port name is displayed in the Device Manager category, Ports (COM & LPT).

.topic 27713
Specifies a port's Port name. The Port name is displayed in the Device Manager category, Ports (COM & LPT).

.topic 27714
Specifies a port's Port description. The user is free to set this to anything desired.

.topic 27715
Specifies a port's Port description. The user is free to set this to anything desired.

.topic 27716
Displays the status of the physical port, which isn't mapped to a COM name. Click the checkbox of the port in the tree on the left to enable the port.

.topic 27717
Allows configuration of the port network profile.

.topic 27718
Shows the network profile configured for this port.

.topic 27719
Click to change the network profile for this port.

.topic 27720
Displays status information about the local COM port, the remote device port, and the network connection(s) between the two.

.topic 27721
Displays status information about the local COM port. I.e., Not open, or Opened by a local application.

.topic 27722
Displays status information about the local COM port. I.e., Not open, or Opened by a local application.

.topic 27723
Displays status information about the remote device RealPort port. I.e., Claimed, Not Claimed, or Unable to claim (because another client has claimed the port).

.topic 27724
Displays status information about the remote device RealPort port. I.e., Claimed, Not Claimed, or Unable to claim (because another client has claimed the port).

.topic 27725
Displays status information about the local UDP port being monitored for incoming data from the device. The port is either Not in use, In use, or Unable to claim (because another local application has already claimed that port).

.topic 27726
Displays status information about the local UDP port being monitored for incoming data from the device. The port is either Not in use, In use, or Unable to claim (because another local application has already claimed that port).

.topic 27727
Displays status information about the local UDP port being used to send data to the device. The port is either Not in use, In use, or Unable to claim (because another local application has already claimed that port).

.topic 27728
Displays status information about the local UDP port being used to send data to the device. The port is either Not in use, In use, or Unable to claim (because another local application has already claimed that port).

.topic 27729
Select the COM names of the other ports on this device to which you would like to copy this port's settings.

.topic 27730
Check to restrict the settings to be copied to be only those found on this page. Otherwise, all port attributes are copied to the selected ports.

.topic 27731
Specifies a port's COM name. To change a port's COM name, choose an available name from the drop-down list.

.topic 27732
Specifies a port's COM name. To change a port's COM name, choose an available name from the drop-down list.

.topic 27733
Configures the default baud rate to use when printing.

.topic 27734
Configures the default parity bits to use when printing.

.topic 27735
Configures the default word size to use when printing.

.topic 27736
Configures the default number of stop bits to use when printing.

.topic 27737
Configures the default flow control to use when printing.

.topic 27738
Normally, Windows only uses these settings as the default settings when printing. To also have RealPort configure the port with these settings on boot, check this box. Note that serial settings are sticky across COM port opens and can be changed programatically by a call to SetCommState, for instance.

.topic 27739
Click to copy this port's settings to one or more other ports.

.topic 27740
Click to view the complete configuration dialog for this port and its device.

.topic 27741
Click to display detailed help about the properties on this page.

.topic 27742
Specifies that the Microsoft Serenum driver should not enumerate devices and modems attached to this port.

.topic 27743
Specifies that the port not write to the System Log (otherwise it records why it cannot be opened when CreateFile fails).

.topic 27744
Ensures local COM port can always be opened but doesn't guarantee physical port on device is available.

.topic 27745
Some Win32 communication functions block while the driver confirms that the device has completed a task (e.g., EscapeCommFunction, SetCommState). This wait is normally on the order of milliseconds but may be delayed by seconds or minutes if TCP is retransmitting packets. I.e., every time a user application calls a Win32 communication function, that thread blocks until the driver completes the request. Check this box if you want the driver to guarantee that Win32 communication function calls will not block.

.topic 27746
Click to configure driver to coalesce multiple bytes before exposing incoming data to application.

.topic 27747
Click to configure how RealPort handles application serial write data when the network is detached or detaching.

.topic 27748
Click to configure custom-application RealPort settings (for applications written specifically for RealPort).

.topic 27749
Click to copy this port's settings to one or more other ports.

.topic 27750
Click to display detailed help about the properties on this page.

.topic 27751
Disables driver message coalescing.

.topic 27752
Enables driver message coalescing based on an end-of-message byte.

.topic 27753
Enables driver message coalescing based on a beginning-of-message byte, a length byte, and a number of overhead bytes.

.topic 27754
The driver will not expose incoming data to the application until it sees this byte.

.topic 27755
The driver will not expose incoming data to the application until it sees this byte.

.topic 27756
The driver recognizes the beginning of a message by this byte.

.topic 27757
The driver recognizes the beginning of a message by this byte.

.topic 27758
Specify the position of the byte that includes the length of the message. A position of 0 means there is no length byte.

.topic 27759
Specify the position of the byte that includes the length of the message. A position of 0 means there is no length byte.

.topic 27760
Specify the position of the byte that includes the length of the message. A position of 0 means there is no length byte.

.topic 27761
Specify how many extra bytes there are after the beginning-of-message byte. These bytes are not indicated by the length byte.

.topic 27762
Specify how many extra bytes there are after the beginning-of-message byte. These bytes are not indicated by the length byte.

.topic 27763
Specify how many extra bytes there are after the beginning-of-message byte. These bytes are not indicated by the length byte.

.topic 27764
Specifies how long RealPort waits for a complete message before timing-out and processing what bytes it already has received.

.topic 27765
Specifies how long RealPort waits for a complete message before timing-out and processing what bytes it already has received.

.topic 27766
Specifies how long RealPort waits for a complete message before timing-out and processing what bytes it already has received.

.topic 27767
Specifies how long RealPort waits for a complete message before timing-out and processing what bytes it already has received.

.topic 27768
Specifies how long RealPort waits for a complete message before timing-out and processing what bytes it already has received.

.topic 27769
Specifies that RealPort throw away incomplete messages if the time-out expires.

.topic 27770
Specifies that RealPort deliver incomplete messages to the application if the time-out expires.

.topic 27771
Specifies how long RealPort should try to resend an application's write data if the network is unavailable when the write is requested.

.topic 27772
Specifies how long RealPort should try to resend an application's write data if the network is unavailable when the write is requested.

.topic 27773
Specifies how long RealPort should try to resend an application's write data if the network is unavailable when the write is requested.

.topic 27774
Specifies how long RealPort should try to resend an application's write data if the network is unavailable when the write is requested.

.topic 27775
Specifies the maximum number of bytes RealPort should try to resend when buffering unsendable data.

.topic 27776
Specifies the maximum number of bytes RealPort should try to resend when buffering unsendable data.

.topic 27777
Specifies the maximum number of bytes RealPort should try to resend when buffering unsendable data.

.topic 27778
Specifies what RealPort does with additional write data once the maximum number of bytes of buffered unsendable data has been reached.

.topic 27779
Specifies that RealPort overwrite the oldest write data once the maximum number of bytes of buffered unsendable data has been reached.

.topic 27780
Specifies that RealPort ignore additional write data once the maximum number of bytes of buffered unsendable data has been reached.

.topic 27781
Specifies that the port always use RTS Toggle flow control, whether or not the application calls SetCommState.

.topic 27782
Specifies that the application using this port is custom-written to understand network error codes, which are not defined by the Microsoft Serial API.

.topic 27783
Specifies that the device drop the port's hardware lines immediately when the port is closed.

.topic 27784
Specifies that the port not double-check and request an updated event packet from the device. Used to be needed for legacy RAS software.

.topic 27785
Contains settings that affect TCP behavior.

.topic 27786
Reduces latency for applications waiting on WriteFile completion.

.topic 27787
If Complete Write Requests Immediately is enabled, the driver will send outgoing serial data to the device as quickly as the user application can call WriteFile. However, this means the device's outgoing serial buffer may fill up before the device physically transmits the data. Normally, the driver will start blocking WriteFile until the device's buffer drains. If you would instead want the driver not to block WriteFile but to just toss the outgoing data instead, enable this feature.

.topic 27788
Reduces latency for applications waiting on SERIAL_EV_TXEMPTY event.

.topic 27789
Specifies that RealPort should pend completion of an application's request to close the COM port until it verifies that all write data has been transmitted.

.topic 27790
Specifies how long RealPort should wait to verify that all write data has been transmitted once an application has requested to close the COM port. Note that a call to CloseHandle may block for as long as the value specified here.

.topic 27791
Specifies how long RealPort should wait to verify that all write data has been transmitted once an application has requested to close the COM port. Note that a call to CloseHandle may block for as long as the value specified here.

.topic 27792
Specifies how long RealPort should wait to verify that all write data has been transmitted once an application has requested to close the COM port. Note that a call to CloseHandle may block for as long as the value specified here.

.topic 27793
Specifies how long RealPort should wait to verify that all write data has been transmitted once an application has requested to close the COM port. Note that a call to CloseHandle may block for as long as the value specified here.

.topic 27794
Check this box if the port on the device is being shared by other applications. Normally, when an application closes a COM port, RealPort lowers the hardware lines for that port, which can cause problems if the port is being shared and still in use by another application.

.topic 27795
Allows you to specify signals that your application doesn't need to control. Information about these signals will not be transferred between this machine and the remote device, thereby reducing network usage. Some applications may not work properly if certain signals are ignored, so be sure to thoroughly test your application after enabling this feature.

.topic 27796
Allows you to specify signals that your application doesn't need to control. Information about these signals will not be transferred between this machine and the remote device, thereby reducing network usage. Some applications may not work properly if certain signals are ignored, so be sure to thoroughly test your application after enabling this feature.

.topic 27797
Click to configure the data notification settings for this port.

.topic 27798
Click to configure the data notification settings for this port.

.topic 27799
Click to copy this port's settings to one or more other ports.

.topic 27800
Click to display detailed help about the properties on this page.

.topic 27801
The Digi RealPort device will wait until it has this many serial bytes before sending a TCP packet.

.topic 27802
The Digi RealPort device will wait until it has this many serial bytes before sending a TCP packet.

.topic 27803
The Digi RealPort device will wait until it has this many serial bytes before sending a TCP packet.

.topic 27804
The Digi RealPort device will wait this many milliseconds after having last sent a TCP packet of received serial data to the driver before sending another packet.

.topic 27805
The Digi RealPort device will wait this many milliseconds after having last sent a TCP packet of received serial data to the driver before sending another packet.

.topic 27806
The Digi RealPort device will wait this many milliseconds after having last sent a TCP packet of received serial data to the driver before sending another packet.

.topic 27807
The Digi RealPort driver will wait until it has consumed this many bytes from the Digi RealPort device until it returns a TCP packet to the device indicating that it can send more serial data.

.topic 27808
The Digi RealPort driver will wait until it has consumed this many bytes from the Digi RealPort device until it returns a TCP packet to the device indicating that it can send more serial data.

.topic 27809
The Digi RealPort driver will wait until it has consumed this many bytes from the Digi RealPort device until it returns a TCP packet to the device indicating that it can send more serial data.

.topic 27810
The Digi RealPort device will wait until it has sent this many bytes of serial data before sending a TCP packet to the driver indicating that the bytes have been sent.

.topic 27811
The Digi RealPort device will wait until it has sent this many bytes of serial data before sending a TCP packet to the driver indicating that the bytes have been sent.

.topic 27812
The Digi RealPort device will wait until it has sent this many bytes of serial data before sending a TCP packet to the driver indicating that the bytes have been sent.

.topic 27813
The Digi RealPort device will wait this many milliseconds after having last sent an update before sending another TCP packet to the driver indicating that bytes have been sent.

.topic 27814
The Digi RealPort device will wait this many milliseconds after having last sent an update before sending another TCP packet to the driver indicating that bytes have been sent.

.topic 27815
The Digi RealPort device will wait this many milliseconds after having last sent an update before sending another TCP packet to the driver indicating that bytes have been sent.

.topic 27816
Click to restore settings on this page to their default values.

.topic 27817
Click to display detailed help about the properties on this page.

.topic 27818
If this is checked, the remote device will not notify the Windows driver or your application when the state of the CTS line signal changes. This affects the EV_CTS event signalled by WaitCommEvent, the fCtsHold member of the COMSTAT structure retrieved from ClearCommError, and the MS_CTS_ON flag set by GetCommModemStatus.

.topic 27819
If this is checked, the remote device will not notify the Windows driver or your application when the state of the DSR line signal changes. This affects the EV_DSR event signalled by WaitCommEvent, the fDsrHold member of the COMSTAT structure retrieved from ClearCommError, and the MS_DSR_ON flag set by GetCommModemStatus.

.topic 27820
If this is checked, the remote device will not notify the Windows driver or your application when the state of the RI line signal changes. This affects the EV_RING event signalled by WaitCommEvent and the MS_RING_ON flag set by GetCommModemStatus.

.topic 27821
If this is checked, the remote device will not notify the Windows driver or your application when the state of the DCD line signal changes. This affects the EV_RLSD event signalled by WaitCommEvent, the fRlsdHold member of the COMSTAT structure retrieved from ClearCommError, and the MS_RLSD_ON flag set by GetCommModemStatus.

.topic 27822
If this is checked, the remote device will not notify the Windows driver or your application when a serial break is received. This affects the EV_BREAK event signalled by WaitCommEvent and CE_BREAK error returned by ClearCommError.

.topic 27823
If this is checked, the remote device will not notify the Windows driver or your application when a serial frame error occurs. This affects the EV_ERR event signalled by WaitCommEvent and CE_FRAME error returned by ClearCommError.

.topic 27824
If this is checked, the remote device will not notify the Windows driver or your application when a serial overrun error occurs. This affects the EV_ERR event signalled by WaitCommEvent and CE_OVERRUN error returned by ClearCommError.

.topic 27825
If this is checked, the remote device will not notify the Windows driver or your application when a serial parity error occurs. This affects the EV_ERR event signalled by WaitCommEvent and CE_RXPARITY error returned by ClearCommError.

.topic 27826
If this is checked, the local RealPort driver will ignore your application's request to change the state of the RTS line. This affects the SETRTS and CLRRTS flags sent to EscapeCommFunction, as well as the fRtsControl member of the COMSTAT structure retrieved from ClearCommError.

.topic 27827
If this is checked, the local RealPort driver will ignore your application's request to change the state of the RTS line. This affects the SETDTR and CLRDTR flags sent to EscapeCommFunction, as well as the fDtrControl member of the COMSTAT structure retrieved from ClearCommError.

.topic 27828
If this is checked, the local RealPort driver will ignore your application's request to set breaks. This affects the SETBREAK and CLRBREAK flags sent to EscapeCommFunction.

.topic 27829
If this is checked, the local RealPort driver will ignore your application's attemps to set the baud rate or serial line settings, such as data bits, parity bits, or stop bits.

.topic 27830
If this is checked, the remote device will not notify the Windows driver or your application when the state of hardware flow control changes on CTS or RTS. This affects the fCtsHold members of the COMSTAT structure retrieved from ClearCommError. Your application will also be unable to set hardware flow control with either of the fOutxCtsFlow or fRtsControl members of the DCB structure sent to SetCommState.

.topic 27831
If this is checked, the remote device will not notify the Windows driver or your application when the state of hardware flow control changes on DSR or DTR. This affects the fDsrHold members of the COMSTAT structure retrieved from ClearCommError. Your application will also be unable to set hardware flow control with either of the fOutxDsrFlow or fDtrControl members of the DCB structure sent to SetCommState.

.topic 27832
If this is checked, the remote device will not notify the Windows driver or your application when the state of software flow control changes. This affects the fXoffHold and fXoffSent members of the COMSTAT structure retrieved from ClearCommError. Your application will also be unable to set software flow control with either of the fOutX or fInX members of the DCB structure sent to SetCommState.

.topic 27833
Click to check all checkboxes on this dialog.

.topic 27834
Click to clear all checkboxes on this dialog.

.topic 27835
Click to display detailed help about the properties on this page.

.topic 27836
Normally, whenever an application configures the settings for a port, RealPort pushes those settings down to the device, regardless of whether or not the port is already configured with those settings. Enable this setting if RealPort should not push settings for a port if the settings match how the port is already configured. This can save some network overhead.

.topic 27837
Specifies that RealPort shouldn't actual relinguish the device connection when an application closes the COM port. Enable this for applications that close and then, soon after, re-open a COM port. This will save some network overhead, reduce latency, and prevent other applications from gaining control of the COM port.

.topic 27838
Specifies how long RealPort should wait once an application closes the COM port until actually relinguishing the port on the device. Enable this for applications that close and then, soon after, re-open a COM port. This will save some network overhead, reduce latency, and prevent other applications from gaining control of the COM port.

.topic 27839
Specifies how long RealPort should wait once an application closes the COM port until actually relinguishing the port on the device. Enable this for applications that close and then, soon after, re-open a COM port. This will save some network overhead, reduce latency, and prevent other applications from gaining control of the COM port.

.topic 27840
Specifies how long RealPort should wait once an application closes the COM port until actually relinguishing the port on the device. Enable this for applications that close and then, soon after, re-open a COM port. This will save some network overhead, reduce latency, and prevent other applications from gaining control of the COM port.

.topic 27841
Click to configure the connection hehavior settings for this port.

.topic 27842
Click to configure the connection hehavior settings for this port.

.topic 27843
Click to copy this port's settings to one or more other ports.

.topic 27844
Click to display detailed help about the properties on this page.

.topic 27845
This setting controls how the driver and device communicate serial data using UDP as the network transport.

.topic 27846
Enter the local port number on which the driver will listen for data from the remote device. Configure this same value for the port on the device, on the UDP Sockets configuration page for the port.

.topic 27847
Enter the local port number on which the driver will listen for data from the remote device. Configure this same value for the port on the device, on the UDP Sockets configuration page for the port.

.topic 27848
Enter the local port number on which the driver will listen for data from the remote device. Configure this same value for the port on the device, on the UDP Sockets configuration page for the port.

.topic 27849
Enter the remote port number to which the driver will send data to the remote device. This value corresponds to the Base Socket value configured on the device, under the Advanced Network Settings section.

.topic 27850
Enter the remote port number to which the driver will send data to the remote device. This value corresponds to the Base Socket value configured on the device, under the Advanced Network Settings section.

.topic 27851
Enter the remote port number to which the driver will send data to the remote device. This value corresponds to the Base Socket value configured on the device, under the Advanced Network Settings section.

.topic 27852
Enter the length of time, in milliseconds, that the driver should wait after having last received outgoing serial data from the application before sending the data to the device. Adjust this setting if you would like to control how the driver coalesces data into each UDP packets.

.topic 27853
Enter the length of time, in milliseconds, that the driver should wait after having last received outgoing serial data from the application before sending the data to the device. Adjust this setting if you would like to control how the driver coalesces data into each UDP packets.

.topic 27854
Enter the length of time, in milliseconds, that the driver should wait after having last received outgoing serial data from the application before sending the data to the device. Adjust this setting if you would like to control how the driver coalesces data into each UDP packets.

.topic 27855
Enter the length of time, in milliseconds, that the driver should wait after having last received outgoing serial data from the application before sending the data to the device. Adjust this setting if you would like to control how the driver coalesces data into each UDP packets.

.topic 27856
Enter the maximum numbers of bytes that the driver will coalesce before sending a UDP packet. This setting complements the data collection timeout.

.topic 27857
Enter the maximum numbers of bytes that the driver will coalesce before sending a UDP packet. This setting complements the data collection timeout.

.topic 27858
Enter the maximum numbers of bytes that the driver will coalesce before sending a UDP packet. This setting complements the data collection timeout.

.topic 27859
Enter the maximum numbers of bytes that the driver will coalesce before sending a UDP packet. This setting complements the data collection timeout.

.topic 27860
Uses the source port of the last-received UDP packet as the destination IP address and port for outgoing packets. If left unchecked, the Base UDP port is used to determine the destination port for outgoing packets.

.topic 27861
This setting controls how the driver and device communicate serial data using UDP as the network transport.

.topic 27862
Waits exactly this long after receiving transmit data from your application via WriteFile before marking the data as having been sent. This setting is like Complete Write Requests Immed. and Signal TXE Immediately, but with a delay.

.topic 27863
Click to copy this port's settings to one or more other ports.

.topic 27864
Click to display detailed help about the properties on this page.

.topic 27865
Retry Frequency specifies how often to try to open the port on the remote device, in milliseconds, when first trying to open the port. Click the Help button for more details.

.topic 27866
Retry Frequency specifies how often to try to open the port on the remote device, in milliseconds, when first trying to open the port. Click the Help button for more details.

.topic 27867
Retry Frequency specifies how often to try to open the port on the remote device, in milliseconds, when first trying to open the port. Click the Help button for more details.

.topic 27868
Retry Frequency specifies how often to try to open the port on the remote device, in milliseconds, when first trying to open the port. Click the Help button for more details.

.topic 27869
Retry Count specifies the number of times to try to open the port on the remote device before backing off and using the Offline Count and Offline Frequency settings. Click the Help button for more details.

.topic 27870
Retry Count specifies the number of times to try to open the port on the remote device before backing off and using the Offline Count and Offline Frequency settings. Click the Help button for more details.

.topic 27871
Retry Count specifies the number of times to try to open the port on the remote device before backing off and using the Offline Count and Offline Frequency settings. Click the Help button for more details.

.topic 27872
Offline Frequency specifies how often to try to open the port on the remote device, once RealPort has already tried as many times as specified by Retry Count. Click the Help button for more details.

.topic 27873
Offline Frequency specifies how often to try to open the port on the remote device, once RealPort has already tried as many times as specified by Retry Count. Click the Help button for more details.

.topic 27874
Offline Frequency specifies how often to try to open the port on the remote device, once RealPort has already tried as many times as specified by Retry Count. Click the Help button for more details.

.topic 27875
Offline Frequency specifies how often to try to open the port on the remote device, once RealPort has already tried as many times as specified by Retry Count. Click the Help button for more details.

.topic 27876
Offline Count specifies how many times to try to open the port on the remote device, once RealPort has already tried as many times as specified by Retry Count. Click the Help button for more details.

.topic 27877
Offline Count specifies how many times to try to open the port on the remote device, once RealPort has already tried as many times as specified by Retry Count. Click the Help button for more details.

.topic 27878
Offline Count specifies how many times to try to open the port on the remote device, once RealPort has already tried as many times as specified by Retry Count. Click the Help button for more details.

.topic 27879
Click to display detailed help about the properties on this page.

.topic 27880
Display statistics about local data.

.topic 27881
Display statistics about remote data.

.topic 27882
Resets all statistics being collected for this device.

.topic 27883
Click to display detailed help about the properties on this page.

.topic 27884
Configures the network settings for this device to be the most reliable and most compatible with all applications.

.topic 27885
Configures the network settings using modified read and write settings. For some applications, this may improve serial write performance or decrease network usage. For other applications, these settings will cause application errors.

.topic 27886
Configures the network settings for this device to be more suitable for byte-conscious or high-latency networks, such as satellite or cellular. This setting is not appropriate for very time-sensitive applications but is appropriate for environments where there's a need to reduce network overhead.

.topic 27887
This setting takes the Less Overhead setting one step further by eliminating keep-alive packets and hardware live event packets. Make sure your application does not need to be notified of hardware line changes before selecting this setting.

.topic 27888
Configures the network settings for this device to use UDP to just send serial data. This setting will save considerable overhead over TCP, but only serial data is transmitted (i.e., your application cannot set the baud rate using SetCommState). Please configure the line settings on your device separately to match your application.

.topic 27889
Check to have the new port profile applied to all ports on this device.